// This file is licensed under the terms of the CC-LGPL.
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas  
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 8 noviembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// El objeto ATPD_AsientoTerrazaPlasticoDomestico se coloca segun
// Minimo <  -350,      0,  -536>*L
// Maximo <   350,    536,    93>*L  
// con el centro inferior de las patas traseras en el origen
// y la silla orientada hacia z-, parte superior hacia y+
//
// acepta los siguientes modificadores
//   #declare ATPD_TexturaAsientoMetal = texture {...}
//             para el metal de la estrutura de soporte
//   #declare ATPD_TexturaMangoSilla   = texture {...}
//             para el manto de la silla
//   #declare ATPD_CuerdaBlanco = texture {...}
//             para las cuerdas plasticas de color blanco
//   #declare ATPD_CuerdaRojo   = texture {...}
//             para las cuerdas plasticas de color rojo
//
// Para colocarlo simplemente 
// #include "AsientoTPD.inc"
// object { ATPD_AsientoTerrazaPlasticoDomestico } 
// o con modificadores podria crearse una silla infantil...      
// #declare ATPD_TexturaAsientoMetal = texture {pigment{color Red}}
// #declare ATPD_TexturaMangoSilla   = texture {pigment{color Yellow}}
// #declare ATPD_CuerdaBlanco = texture {pigment{color Blue}}
// #declare ATPD_CuerdaRojo   = texture {pigment{color Green}}
// #include "AsientoTPD.inc"
// object { ATPD_AsientoTerrazaPlasticoDomestico scale 0.75 }
//


#include "colors.inc"
#include "AsientoTPD.inc"

#declare ATPD_OjoAbsoluto            = 256;
#declare ATPD_VecesCentroAbsoluto    = 10;     
#declare ATPD_L                      = 0.001;
camera {
  location <   0,  0, 
        -( ATPD_VecesCentroAbsoluto+1 )*ATPD_OjoAbsoluto >*ATPD_L
  look_at  <   0,  0, 
        -ATPD_VecesCentroAbsoluto*ATPD_OjoAbsoluto >*ATPD_L  
}         
light_source    {
         < 500  , 500   , -3000 >*ATPD_L
         White
}
background      {
         Gray50
}    

#local   ATPD_FactorAcercamiento     = 2.5;
               
object  {          
  ATPD_AsientoTerrazaPlasticoDomestico
  rotate        20*y
  translate     -250*y*ATPD_L+175*x*ATPD_L
  translate       -( ATPD_VecesCentroAbsoluto+1 )
                        *( ATPD_FactorAcercamiento-1 )
        /( ATPD_FactorAcercamiento )*ATPD_OjoAbsoluto*ATPD_L*z   
    
}  
