// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 30 diciembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// Se crean cuatro esquineros simples de hogar.  Se ubican
// segun la siguiente descripcion:
// EsquineroMetalTriple
// RadioPlano           = 215*L
// Radio                = 217*L
// Alto                 = 890*L
// PrimerNivel          = 112*L
// SegundoNivel         = 441*L
// TercerNivel          = 777*L
// CadaNivelAdicional   = 336*L  
//      El objeto se ubica orientado hacia x+ z-, <1,0,-1>
//      el origen en la parte inferior, al vertice del cuadrante
// EsquineroPlasticoTriple
// RadioPlano           = 130*L
// Radio                = 148*L
// Alto                 = 552*L
// PrimerNivel          = 108.5*L
// SegundoNivel         = 322.5*L
// TercerNivel          = 536.5*L
// CadaNivelAdicional   = 214*L  
//      El origen en la parte inferior centrada
//      las patas alineadas en paralelo a los ejes x y z
// EsquineroVidrioPisoSimple
// Radio                = 160*L
// RadioLibre           = 113*L
// Alto                 = 362.5*L
//      El origen en la parte inferior centrada
//      los laterales orientados paralelos a los ejes x y z
// EsquineroVidrioDobleAlto
// RadioPlano           = 360*L
// Radio                = 377*L
// Alto                 = 32*L
// PrimerNivel          = 17*L
// SegundoNivel         = 317*L
// CadaNivelAdicional   = 300*L
// Altura Recomendada   = 875*L (translate 875*L*y Ver macro)
//      El objeto se ubica orientado hacia x+ z-, <1,0,-1>
//      el origen en la parte inferior, al vertice del cuadrante
//      mas 875*L*y optativo
// 
// Los objetos respectivos se declaran como macros
// EHEV_EsquineroMetalTriple()
// EHEV_EsquineroPlasticoTriple()
// EHEV_EsquineroVidrioPisoSimple()
// EHEV_EsquineroVidrioDobleAlto( BanderaAlto )
//      BanderaAlto     : si TRUE aplica translate 875*L*y
// Para su utilizacion simplemente...
// include "EsquineroHEV.inc" 
// object { EHEV_EsquineroMetalTriple() } 
//
// o bien este otro ejemplo...
// object { EHEV_EsquineroVidrioDobleAlto( true ) }
//
// Los objetos tambien pueden generarse y alterarse mediante
// un llamado directo a la macro general
// EHEV_EsquineroHogarEspacioVacio 
//        ( Estilo, Param1, Param2, Textura1, Textura2, Material1 )
// Estilo       : los cuatro estilos se identifican con los valores
//        ( se indican valores Default )
//      EHEV_MetalTriple
//              Param1          : radio del esquinero, 215*L 
//              Param2          : 0 o mas pisos adicionales a tres, 
//                                      default 0
//              Textura1        : se aplica a los soportes metalicos
//                                      del vidrio,
//                                      EHEV_TexturaMetalTriple
//              Textura2        : se aplica texture a las figuras "S" 
//                                      decorativas y a la barra,
//                                      EHEV_TexturaSMetalTriple
//              Material1       : se aplica material al vidrio
//                                      EHEV_VidrioMetalTriple
//      EHEV_PlasticoTriple
//              Param1          : diametro plano del esquinero, 260*L 
//              Param2          : total de pisos, 3
//              Textura1        : se aplica texture al soporte que rodea
//                                      al circulo central,
//                                      EHEV_TexturaPlasticoTriple
//              Textura2        : se aplica texture a las patas, incluye
//                                      el exceso final hacia y+, 
//                                      EHEV_TexturaPatasPlasticoTriple
//              Material1       : se aplica material al circulo central
//                                      EHEV_MaterialPlasticoTriple
//      EHEV_VidrioPisoSimple
//              Param1          : permite colocar "mal" el vidrio 
//                                      agregando un rotate Param1*y luego
//                                      se aplica Param2, 0 
//              Param2          : permite colocar "mal" el vidrio
//                                      agregando translate Param2*<1,0,1>
//                                      se ignora y, <0,0,0>
//              Textura1        : se aplica texture a las partes doradas 
//                                      de la base,
//                                      EHEV_TexturaDoradaVidrioPisoSimple
//              Textura2        : se aplica texture a las patas en 
//                                      zona negra
//                                      EHEV_TexturaNegraVidrioPisoSimple
//              Material1       : se aplica material al vidrio
//                                      EHEV_MaterialVidrioPisoSimple
//      EHEV_VidrioDobleAlto
//              Nota: esta macro no aplica el translate 875*L*y,
//                      de la macro EHEV_EsquineroVidrioDobleAlto( true )
//              Param1          : grosor del soporte de madera, 32*L 
//              Param2          : total de pisos, 2
//              Textura1        : se aplica texture al soporte que rodea
//                                      al vidrio,
//                                      EHEV_TexturaVidrioDobleAlto
//              Textura2        : se aplica texture a la esfera que
//                                      finaliza los soportes,
//                                      EHEV_TexturaEsferaVidrioDobleAlto
//              Material1       : se aplica material al vidrio,
//                                      EHEV_MaterialVidrioDobleAlto 
// Ejemplo 
// object       {
//   EHEV_EsquineroHogarEspacioVacio
//      ( EHEV_PlasticoTriple, 500*L, 2, texture { PinkAlabaster },
//                texture { PinkAlabaster }, 
//                material { texture { PinkAlabaster} } )
// }  
// Para el diseo de su dibujo, la macro genera automaticamente
// las siguientes variables
// EHEV_TotalPisos      : indica el total de pisos de la figura
// EHEV_AlturaPisos     : array, indice de 0 hasta EHEV_TotalPisos-1,
//      que indica la altura de superficie del piso
// Se borran y reescriben con cada llamado a la macro  
// Nota: el tipo EHEV_EsquineroVidrioPisoSimple solo define un piso
// Ejemplo (coloca el cilindro sobre el esquinero)
// include "EsquineroHEV.inc"
// union       {
//   object { EHEV_EsquineroVidrioPisoSimple() }
//   cylider    { 
//     0, 0.01, 0.01 
//     translate EHEV_AlturaPisos[ 0 ]*y
//     pigment { Red }  
//   } 
// }
//
// Otros modificadores validos redefinibles serian:
//    (si se indica es default)
//      La mayoria de estas texturas se aplicarian si se
//      utiliza el objeto default   
// #declare EHEV_POV3_1                         = off;
//      Al activarse permite compatibilidad con POVRay 3.1.
//      En algunas versiones POVRay podra activarse automticamente.
// #declare EHEV_TexturaMetalTriple             = texture      { ... }
//      Se aplica al soporte que rodea y sostiene el vidrio
//      en esquinero tipo EHEV_MetalTriple
// #declare EHEV_TexturaSMetalTriple            = texture      { ... }
//      Se aplica a las "S" decorativas 
//      y la barra en tipo EHEV_MetalTriple
// #declare EHEV_VidrioMetalTriple              = material     { ... }
//      Se aplica al vidrio en EHEV_MetalTriple
// #declare EHEV_TexturaPlasticoTriple          = texture      { ... }
//      Se aplica al soporte tipo toroidal que rodea el centro plano
//      en el tipo EHEV_PlasticoTriple
// #declare EHEV_TexturaPatasPlasticoTriple     = texture      { ... } 
//      Se aplica a las patas y final de patas en
//      tipo EHEV_PlasticoTriple
// #declare EHEV_MaterialPlasticoTriple         = material     { ... }
//      Se aplica al centro plano de los soportes
//      en tipo EHEV_PlasticoTriple
// #declare EHEV_MaterialVidrioPisoSimple       = material     { ... }
//      Se aplica al vidrio del tipo EHEV_VidrioPisoSimple
// #declare EHEV_TexturaDoradaVidrioPisoSimple  = texture      { ... } 
//      Se aplica a la zona dorada del tipo EHEV_VidrioPisoSimple
// #declare EHEV_TexturaNegraVidrioPisoSimple   = texture      { ... }
//      Se aplica a la zona negra del tipo
//      EHEV_VidrioPisoSimple
// #declare EHEV_ColorMaderaVidrioDobleAlto     = White;
//      Para cambiar el color, pero mantener textura del soporte
//      en el tipo EHEV_VidrioPisoSimple, util si no se redefine
//      EHEV_TexturaSoporteVidrioDobleAlto
// #declare EHEV_MaterialVidrioDobleAlto        = material     { ... }
//      Para aplicar al vidrio
//      en EHEV_VidrioDobleAlto
// #declare EHEV_TexturaSoporteVidrioDobleAlto  = texture      { ... }
//      Para aplicar a los soportes en EHEV_VidrioDobleAlto,
//      si solo se quiere cambiar el color (por ejemplo pared Blue),
//      se recomienda usar EHEV_ColorMaderaVidrioDobleAlto (mas facil)
// #declare EHEV_TexturaEsferaVidrioDobleAlto   = texture      { ... }
//      Para aplicar a la esfera final del soporte de madera
//      en tipo EHEV_VidrioDobleAlto
// Ejemplo:
// #declare EHEV_ColorMaderaVidrioDobleAlto     = Orange;
// include "EsquineroHEV.inc"
// object { EHEV_EsquinerVidrioDobleAlto( true ) }      
//  

#include "colors.inc"
#include "textures.inc" 
#include "metals.inc" 
#include "woods.inc"     

#ifndef ( EHEV_POV3_1 )           
  #if ( version < 3.2 )
    #declare EHEV_POV3_1        = on;
  #else
    #declare EHEV_POV3_1        = off;
  #end
#end

#declare EHEV_MetalTriple       = 1;
#declare EHEV_PlasticoTriple    = 2;
#declare EHEV_VidrioPisoSimple  = 3;
#declare EHEV_VidrioDobleAlto   = 4;   

#ifndef ( EHEV_TexturaMetalTriple )
  #declare EHEV_TexturaMetalTriple      = texture       {
    pigment     { Gray20 }
  }
#end

#ifndef ( EHEV_TexturaSMetalTriple )
  #declare EHEV_TexturaSMetalTriple     = texture       {
    pigment     { Gray20 }
  }
#end

#ifndef ( EHEV_VidrioMetalTriple )
  #declare EHEV_VidrioMetalTriple       = material   {
    #if ( EHEV_POV3_1 )
      texture   {
        pigment { rgbt <0.7,1.0,1.0,0.7>}
      }
    #else
    M_Glass2
    #end
  }
#end  

#ifndef ( EHEV_TexturaPlasticoTriple )
  #declare EHEV_TexturaPlasticoTriple           = texture       {
    pigment     { Gray95 }
  }
#end

#ifndef ( EHEV_TexturaPatasPlasticoTriple )
  #declare EHEV_TexturaPatasPlasticoTriple      = texture       {
    pigment     { Gray95 }
  }
#end

#ifndef ( EHEV_MaterialPlasticoTriple ) 
  #declare EHEV_MaterialPlasticoTriple          = material      {
    texture     {
      pigment     { Gray95 }
    }
  }
#end 

#ifndef ( EHEV_MaterialVidrioPisoSimple )
  #declare EHEV_MaterialVidrioPisoSimple       = material   {
    #if ( EHEV_POV3_1 )
      texture   {
        pigment { rgbt <0.7,1.0,1.0,0.7>}
      }
    #else
    M_Dark_Green_Glass
    #end
  }
#end
    
#ifndef ( EHEV_TexturaDoradaVidrioPisoSimple )
  #declare EHEV_TexturaAmarilla                 = texture       {
    pigment     { Gold }
  }
  #declare EHEV_TexturaDoradaVidrioPisoSimple   = texture       {
    average     
    texture_map         {
      [ 0.7 T_Gold_5E ]
      [ 0.3 EHEV_TexturaAmarilla ]
    }
  }
#end

#ifndef ( EHEV_TexturaNegraVidrioPisoSimple )
  #declare EHEV_TexturaNegraVidrioPisoSimple    = texture       {
    pigment     { 
      spotted 
      turbulence        0.5
      scale     0.05
      pigment_map {
        [ 0.7 Gray20 ]
        [ 0.7 Gray30 ]
      }
   }
  }
#end   

#ifndef ( EHEV_ColorMaderaVidrioDobleAlto )
  #declare EHEV_ColorMaderaVidrioDobleAlto      = White;
#end

#ifndef ( EHEV_MaterialVidrioDobleAlto )
  #declare EHEV_MaterialVidrioDobleAlto         = material      {
    #if ( EHEV_POV3_1 )
      texture   {
        pigment { rgbt <0.7,1.0,1.0,0.7>}
      }
    #else
    M_NB_Old_Glass
    #end
  }
#end

#declare EHEV_TexturaWhite                      = texture       {
  pigment       { EHEV_ColorMaderaVidrioDobleAlto }
}

#ifndef ( EHEV_TexturaSoporteVidrioDobleAlto )  
  #declare EHEV_TexturaSoporteVidrioDobleAlto   = texture       {
     average
     texture_map        {
       [ 0.2 T_Wood9           ]
       [ 0.8 EHEV_TexturaWhite ]
     }
  }
#end

#ifndef ( EHEV_TexturaEsferaVidrioDobleAlto )   
  #declare EHEV_TexturaEsferaVidrioDobleAlto    = texture       {
    EHEV_TexturaSoporteVidrioDobleAlto
  }
#end

#macro EHEV_EsquineroBasico ( RadioEstante, GruesoVidrio, 
                                ExcesoVidrioAire, ExcesoMadera,
                                Textura1, Textura2, Material1 )
      #local DiametroTotalMadera        = 
                        2*ExcesoMadera+GruesoVidrio+ExcesoVidrioAire;
                       
      union     { 
        difference      {
          cylinder        {
            0     , GruesoVidrio*y        ,
            RadioEstante
            translate     ExcesoMadera*y
          }
          plane         {
            -z  , 0
          }
          plane         {
            x   , 0
          }
          material      { 
            Material1
          }
        }
        difference      {
          union         {
            cylinder      {
              0   , ( RadioEstante+ExcesoVidrioAire )*x   ,
              DiametroTotalMadera/2
              translate   DiametroTotalMadera/2*y
            } 
            sphere      {
              ( RadioEstante+ExcesoVidrioAire )*x+DiametroTotalMadera/2*y,
              DiametroTotalMadera/2 
              texture   { Textura2 }
            }
          }
          plane         {
            -z  , 0
          }
          box           {
            ExcesoVidrioAire*<-1,0,1>  , 
            < RadioEstante+ExcesoVidrioAire, 
                GruesoVidrio+ExcesoVidrioAire, -DiametroTotalMadera >
            translate   ExcesoMadera*y
          } 
        } 
        difference      {
          union         {
            cylinder      {
              0   , ( RadioEstante+ExcesoVidrioAire )*x   ,
              DiametroTotalMadera/2
              translate   DiametroTotalMadera/2*y
            } 
            sphere      {
              ( RadioEstante+ExcesoVidrioAire )*x+DiametroTotalMadera/2*y,
              DiametroTotalMadera/2
              texture   { Textura2 }
            }
          }
          plane         {
            -z  , 0
          }
          box           {
            ExcesoVidrioAire*<-1,0,1>  , 
            < RadioEstante+ExcesoVidrioAire, 
                GruesoVidrio+ExcesoVidrioAire, -DiametroTotalMadera >
            translate   ExcesoMadera*y
          }
          translate     -DiametroTotalMadera/2*y 
          rotate        180*x+90*y  
          translate     +DiametroTotalMadera/2*y
        } 
        texture { Textura1 }
      }
#end

#macro EHEV_EsquineroHogarEspacioVacio 
        ( Estilo, Param1, Param2, Textura1, Textura2, Material1 ) 
  #local L                      = 0.001;
  #switch ( Estilo )
    #case ( EHEV_MetalTriple        ) 
      #macro EHEV_EseDecorativa ( Curva, Largo, Grueso )
        // Curva : es el diametro del circulo de la S
        #local FactorBajoCurva  = 0.9;
        #local CentroCurva      = < 0, ( Largo-Curva )/2, 0 >;
        #local BajoCurva        = 
                < Curva/4, Largo/2-FactorBajoCurva*Curva, 0 >;
        #local LadoCurva        = < Curva/2, CentroCurva.y, 0 >;
        #local AltoCurva        = < 0, Largo/2, 0 >;
                                 
        #if ( EHEV_POV3_1 )                         
          union         {
            cylinder    {
              CentroCurva               ,
              BajoCurva                 ,
              Grueso
            }   
            cylinder    {
              CentroCurva               ,
              LadoCurva                 ,
              Grueso
            }
            cylinder    {
              LadoCurva                 ,
              AltoCurva                 ,
              Grueso
            }
            cylinder    {
              AltoCurva                 ,
              LadoCurva*<-1,1,1>        ,
              Grueso
            }    
            cylinder    {
              LadoCurva*<-1,1,1>        ,
              LadoCurva*<1,-1,1>        ,
              Grueso
            }
            cylinder    {
              LadoCurva*<1,-1,1>        ,
              AltoCurva*<-1,-1,1>       ,
              Grueso
            }
            cylinder    {
              AltoCurva*<-1,-1,1>       ,
              LadoCurva*<-1,-1,1>       ,
              Grueso
            }
            cylinder    {
              LadoCurva*<-1,-1,1>       ,
              BajoCurva*<-1,-1,1>       ,
              Grueso
            }
            cylinder    {
              BajoCurva*<-1,-1,1>       ,
              CentroCurva*<-1,-1,1>     ,
              Grueso
            }
          }
        #else
        sphere_sweep    {
          cubic_spline      
          12,
          AltoCurva             , Grueso/2,
          CentroCurva           , Grueso/2,
          BajoCurva             , Grueso/2,
          LadoCurva             , Grueso/2,
          AltoCurva             , Grueso/2,
          LadoCurva*<-1,1,1>    , Grueso/2,
          LadoCurva*<1,-1,1>    , Grueso/2,
          AltoCurva*<-1,-1,1>   , Grueso/2,         
          LadoCurva*<-1,-1,1>   , Grueso/2,
          BajoCurva*<-1,-1,1>   , Grueso/2,
          CentroCurva*<-1,-1,1> , Grueso/2,
          AltoCurva*<-1,-1,1>   , Grueso/2  
          tolerance     1e-7  
          texture       { Textura2 }
        }
        #end
      #end
      
      union     {
        #local GruesoBarra              = 10*L;
        #local AlturaPrimerNivel        = 107*L;
        #local AlturaSegundoNivel       = 436*L;  
        #local AlturaTercerNivel        = 772*L;
        #local SeparacionPisoExtra      = 
                AlturaTercerNivel-AlturaSegundoNivel;
        #local AlturaBarra              = 840*L
                +SeparacionPisoExtra*( Param2 );
        #local AlturaEstante            = 890*L
                +SeparacionPisoExtra*( Param2 );
        #local AlturaUltimoNivel        =
                AlturaTercerNivel+SeparacionPisoExtra*( Param2 );
        #local AltoNivel                = 10*L;
        #local ProfundidadTiraNivel     = 14*L;
                // se refiere a unos rectangulos que soportan vidrios
        #local RadioNivel               = Param1;
        #local GruesoNivel              = 2*L;
        #local GruesoVidrio             = 3*L;
        #local DiametroMenorS   = 42*L;
        #local DiametroMedioS   = 54*L;
        #local DiametroMayorS   = 70*L;
        #local GruesoS          = 7*L;
        #local AnguloCorreccion = 11;
           // funciona bien si PAram1 = 215*L
           // valores muy diferentes de Param1 requieren cambiar
           // este valor     
        
        #macro Estante  ( )
          union         {
            difference  {
              cylinder  {
                0               , AltoNivel*y           ,
                RadioNivel
              }
              cylinder  {
                -0.01*y         , AltoNivel*y*1.01      ,
                RadioNivel-GruesoNivel
              }           
              plane     {
                x       , 0             
              }
              plane     {
                -z      , 0             
              }
            }
            difference  {
              cylinder  {
                0               , GruesoVidrio*y           ,
                RadioNivel-2*GruesoNivel
              }
              plane     {
                x       , 0             
              }
              plane     {
                -z      , 0             
              }
              translate GruesoNivel*<1,1,-1>
              material   {
                Material1
              }
            }
            box         {
              0         ,
              < RadioNivel, AltoNivel   , -GruesoNivel >
            } 
            box         {
              0         ,
              < GruesoNivel, AltoNivel  , -RadioNivel  >
            }
            difference  {
              #local PuntoBaseNivel     =
                < 2*RadioNivel, GruesoNivel, ProfundidadTiraNivel/2 >;
              union     {
                box     {
                  -PuntoBaseNivel*<1,0,1>, PuntoBaseNivel                  
                  rotate        10*y
                  translate     -0.3*RadioNivel*z
                }
                box     {
                  -PuntoBaseNivel*<1,0,1>, PuntoBaseNivel                  
                  rotate        80*y
                  translate     +0.3*RadioNivel*x
                }
              }
              plane     {
                x       , 0             
              }
              plane     {
                -z      , 0             
              } 
              sphere    {
                0       , RadioNivel
                inverse
              }
            }
          }
        #end
        
        
        object  {
          cylinder      {
            0   , AlturaBarra*y,
            GruesoBarra/2 
            translate   GruesoBarra/2*<1,0,-1> 
            texture     { Textura2 }
          }
        } 
        object  {
          Estante()   
          translate     AlturaPrimerNivel*y
        }
        object  {
          Estante()   
          translate     AlturaSegundoNivel*y
        }  
        
        // patitas
        #if ( EHEV_POV3_1 )
          #local PivRaiz        = sqrt( DiametroMenorS*DiametroMenorS
                                +RadioNivel*RadioNivel );
          #local AnguloEspecialPatitas  =
                        degrees( asin( DiametroMenorS/PivRaiz ) );
        #else
        #local AnguloEspecialPatitas    =
                degrees( atan( DiametroMenorS/RadioNivel ) );
        #end
        #local AnguloCorreccionPatitas  = 
                        0.2*AnguloEspecialPatitas;
        object  {
          EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS ) 
          rotate        180*y
          translate     -RadioNivel*z+AlturaPrimerNivel/2*y 
          rotate -AnguloEspecialPatitas/2*y
          rotate AnguloCorreccionPatitas*y   
        }
        object  {
          EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS )  
          translate     -RadioNivel*z+AlturaPrimerNivel/2*y 
          rotate -3*AnguloEspecialPatitas/2*y
          rotate -AnguloCorreccionPatitas*y       
          
        }
        object  {
          EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS )
          translate     -RadioNivel*z+AlturaPrimerNivel/2*y 
          rotate ( -90+AnguloEspecialPatitas/2 )*y
          rotate -AnguloCorreccionPatitas*y
        }
        object  {
          EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS )
          rotate        180*y
          translate     -RadioNivel*z+AlturaPrimerNivel/2*y 
          rotate ( -90+3*AnguloEspecialPatitas/2 )*y
          rotate AnguloCorreccionPatitas*y
        }
        //  Ese Decorativas
        object  {
          EHEV_EseDecorativa
                ( DiametroMayorS, 
                AlturaSegundoNivel-AlturaPrimerNivel-AltoNivel, GruesoS )
          rotate        90*y
          translate     ( -RadioNivel+DiametroMayorS/2 )*z
                        +( 0.5*AlturaPrimerNivel+
                        0.5*AltoNivel+AlturaSegundoNivel/2 )*y 
        }
        object  {
          EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS )
          rotate        90*z
          translate     AlturaPrimerNivel/2*x
          rotate        -AnguloCorreccion*y
          rotate        15*z
          translate     -RadioNivel*z+
                ( -DiametroMenorS/2+AlturaPrimerNivel+
                0.94*( AlturaSegundoNivel-AlturaPrimerNivel ) )*y
                +( GruesoS )*x
        }
        object  {
          EHEV_EseDecorativa
                ( DiametroMayorS, 
                AlturaSegundoNivel-AlturaPrimerNivel-AltoNivel, GruesoS )
          rotate        90*y
          translate     ( -RadioNivel+DiametroMayorS/2 )*z
                        +( 0.5*AlturaPrimerNivel+
                        0.5*AltoNivel+AlturaSegundoNivel/2 )*y 
          rotate        -90*y
        }
        object  {
          EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS )
          rotate        90*z
          rotate        +90*y
          translate     -AlturaPrimerNivel/2*z
          rotate        +AnguloCorreccion*y
          rotate        15*x
          translate     +RadioNivel*x+
                ( -DiametroMenorS/2+AlturaPrimerNivel+
                0.94*( AlturaSegundoNivel-AlturaPrimerNivel ) )*y
                -( GruesoS )*z
        }
        #local EstanteExtra   = union         {
          object  {
            Estante()   
            translate     AlturaTercerNivel*y
          }   
          object  {
            EHEV_EseDecorativa
                  ( DiametroMayorS, 
                 AlturaTercerNivel-AlturaSegundoNivel-AltoNivel, GruesoS )
            rotate        90*y
            translate     ( -RadioNivel+DiametroMayorS/2 )*z
                        +( 0.5*AlturaSegundoNivel+
                        0.5*AltoNivel+AlturaTercerNivel/2 )*y 
          }
          object  {
            EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS )
            rotate        90*z
            translate     AlturaPrimerNivel/2*x
            rotate        -AnguloCorreccion*y
            rotate        15*z
            translate     -RadioNivel*z+
                ( -DiametroMenorS/2+AlturaSegundoNivel+
                0.94*( AlturaTercerNivel-AlturaSegundoNivel ) )*y
                +( GruesoS )*x
          }
          object  {
            EHEV_EseDecorativa
                ( DiametroMayorS, 
                AlturaTercerNivel-AlturaSegundoNivel-AltoNivel, GruesoS )
            rotate        90*y
            translate     ( -RadioNivel+DiametroMayorS/2 )*z
                        +( 0.5*AlturaSegundoNivel+
                        0.5*AltoNivel+AlturaTercerNivel/2 )*y 
            rotate        -90*y
          }        
          object  {
            EHEV_EseDecorativa
                ( DiametroMenorS, AlturaPrimerNivel, GruesoS )
            rotate        90*z
            rotate        +90*y
            translate     -AlturaPrimerNivel/2*z
            rotate        +AnguloCorreccion*y
            rotate        15*x
            translate     +RadioNivel*x+
                ( -DiametroMenorS/2+AlturaSegundoNivel+
                0.94*( AlturaTercerNivel-AlturaSegundoNivel ) )*y
                -( GruesoS )*z
          }
        }  // hasta asqui el declare de estante extra 
        #local C        = 0;
        #while ( C < ( Param2+1 ) )
          object  {
            EstanteExtra
            translate     C*SeparacionPisoExtra*y
          } 
          #local C      = C+1;
        #end
        #if ( EHEV_POV3_1 )
          #local PivSup         = ( AlturaBarra-AlturaUltimoNivel-AltoNivel );
          #local PivRaiz        = sqrt( PivSup*PivSup+RadioNivel*RadioNivel );
          #local AnguloSFinal   = degrees( asin( PivSup/PivRaiz ) );
        #else
        #local AnguloSFinal     =
             degrees( atan ( ( AlturaBarra-AlturaUltimoNivel-AltoNivel )
                /RadioNivel ) );
        #end
        object  {
          EHEV_EseDecorativa
                ( DiametroMedioS, RadioNivel, GruesoS )
          rotate        90*z
          rotate        -AnguloSFinal*z
          translate     0.5*( AlturaBarra+AlturaUltimoNivel
                +0.5*DiametroMedioS+AltoNivel )*y
                +( RadioNivel/2+GruesoBarra/2 )*x
        }
        object  {
          EHEV_EseDecorativa
                ( DiametroMedioS, RadioNivel, GruesoS )
          rotate        90*z
          rotate        -AnguloSFinal*z
          translate     0.5*( AlturaBarra+AlturaUltimoNivel
                +0.5*DiametroMedioS+AltoNivel )*y
                +( RadioNivel/2+GruesoBarra/2 )*x  
          rotate        90*y
        }
        
        texture {
          Textura1 
        }  
      } 
      #declare EHEV_TotalPisos  = 3+Param2;
      #declare EHEV_AlturaPisos = array [ EHEV_TotalPisos ]
      #declare EHEV_AlturaPisos[ 0 ]    = 
                AlturaPrimerNivel+GruesoNivel+GruesoVidrio;
      #declare EHEV_AlturaPisos[ 1 ]    = 
                AlturaSegundoNivel+GruesoNivel+GruesoVidrio;
      #declare EHEV_AlturaPisos[ 2 ]    = 
                AlturaTercerNivel+GruesoNivel+GruesoVidrio;
      #local C          = 0;
      #while ( C < Param2 )
        #declare EHEV_AlturaPisos[ 3+C ]        = 
                AlturaTercerNivel+( C+1 )*SeparacionPisoExtra
                +GruesoNivel+GruesoVidrio;
        #local C        = C+1;                
      #end
    #break
    #case ( EHEV_PlasticoTriple     ) 
      #local DiametroMayor              = Param1;
      #local TotalPisos                 = Param2;
      #local DiametroInternoTorus       = 18*L;
      #local GruesoPlano                = 1.5*L;   
      #local PrimerPiso                 = 107*L;
      #local SeparacionPiso             = 2*PrimerPiso;  
      #local AltoPataPlastico           =  PrimerPiso
                +SeparacionPiso*( TotalPisos-1 )+DiametroInternoTorus/2;
      #local FraccionGruesoPata         = 0.8;
      #local FraccionHuecoPata          = 0.85;
                
      #macro EHEV_BasePlano ()
        union   {
          cylinder      {
            0   , GruesoPlano*y         ,
            ( DiametroMayor/2-DiametroInternoTorus )
            material    { Material1 }            
          }
          difference    {
            torus       {
              ( DiametroMayor-DiametroInternoTorus )/2  ,
              DiametroInternoTorus/2
            }
            torus       {
              ( DiametroMayor-DiametroInternoTorus )/2  ,
              DiametroInternoTorus/2-GruesoPlano
            }
            plane       {
              y         , 0
            }
          }
          difference    {
            cylinder    {
              -DiametroInternoTorus/2*y         , 0     ,
              DiametroMayor/2
            }
            cylinder    {
              -1.1*DiametroInternoTorus/2*y     , 0.1*y ,
              DiametroMayor/2-GruesoPlano
            }
          }
          #local C      = 0;
          #while ( C < 4 )
            difference  {
              cylinder  {
                -DiametroInternoTorus/2*y       ,
                DiametroInternoTorus/2*y        ,
                DiametroInternoTorus/2
              }
              cylinder  {
                -1.1*DiametroInternoTorus/2*y       ,
                1.1*DiametroInternoTorus/2*y        ,
                FraccionHuecoPata*DiametroInternoTorus/2
              }
            translate   ( DiametroMayor-DiametroInternoTorus )/2*x
            rotate      ( 45+90*C )*y              
            }
            #local C    = C+1;
          #end
          texture       { Textura1 }
        }
      #end   

      #macro EHEV_PataPlastico ()
        union   {
          cylinder      {
            0   , AltoPataPlastico*y    ,
            FraccionGruesoPata*DiametroInternoTorus/2
          }
          difference    {
            sphere      {
              0   , FraccionGruesoPata*DiametroInternoTorus/2
            }
            plane       {
              y   , 0
            }
            translate   AltoPataPlastico*y
          }
        }
      #end
      
      union     {  
        #local  C       = 0;
        #while ( C < TotalPisos )
          object  {
            EHEV_BasePlano()
            translate   ( PrimerPiso+C*SeparacionPiso )*y
          }    
          #local C      = C+1;
        #end
        #local C        = 0;
        #while ( C < 4 )
          object        {  
            EHEV_PataPlastico()
            translate   ( DiametroMayor-DiametroInternoTorus )/2*x
            rotate      ( 45+90*C )*y
          }
          #local C      = C+1;
        #end
        texture {
          Textura2
        }
      } 
      
      #declare EHEV_TotalPisos  = Param2; 
      #declare EHEV_AlturaPisos = array [ EHEV_TotalPisos ]
      #local C                  = 0;
      #while ( C < Param2 )
        #declare EHEV_AlturaPisos[ C ]           = 
                PrimerPiso+C*SeparacionPiso+GruesoPlano;
        #local C        = C+1;                
      #end
    #break
    #case ( EHEV_VidrioPisoSimple   )
      #local LadoBaseCuadrado           = 200*L;
      #local AltoBaseCuadrado           = 358*L;
      #local DiametroBasicoPata         = 38*L;
      #local DiametroMayorPata          = 40*L;
      #local DiametroDecorativo         = 5*L;
      #local AlturaPrimerSoporte        = 43*L;
      #local AlturaSegundoSoporte       = 287*L;
      #local AltoSoporte                = 18*L;
      #local GruesoSoporte              = 11*L;
      #local LadoVerticeVidrio  = 320*L;
      #local GruesoVidrio       = 4.5*L;
         
      #macro PataEsquineroVidrio ()
        union   {
          union         {
            cylinder      {
              0   , DiametroDecorativo*y  ,
              DiametroMayorPata/2
            }  
            torus       {
              DiametroMayorPata/2       ,
              DiametroDecorativo/2
              translate         DiametroDecorativo/2*y
            }
            difference  {
              cylinder  {
                0       , 
                ( AlturaPrimerSoporte+2*DiametroDecorativo
                        +AltoSoporte )*y        ,
                DiametroBasicoPata/2
              }
              torus     {
                DiametroBasicoPata/2    ,
                DiametroDecorativo
                //  efectivamente el doble del diametro decorativo
                translate       3*DiametroDecorativo*y
              }
            }
            torus       {
              DiametroBasicoPata/2      ,
              DiametroDecorativo/2
              translate         
                ( AlturaPrimerSoporte-1.5*DiametroDecorativo )*y
            }
            torus       {
              DiametroBasicoPata/2      ,
              DiametroDecorativo/2
              translate         
              ( AlturaPrimerSoporte+AltoSoporte+1.5*DiametroDecorativo )*y
            }
            cylinder    {
              ( AlturaSegundoSoporte-DiametroDecorativo )*y    ,
              ( AlturaSegundoSoporte+AltoSoporte+2*DiametroDecorativo )*y,
              DiametroBasicoPata/2
            }
            torus       {
              DiametroBasicoPata/2      ,
              DiametroDecorativo/2
              translate         
                ( AlturaSegundoSoporte-1.5*DiametroDecorativo )*y
            }
            torus       {
              DiametroBasicoPata/2      ,
              DiametroDecorativo/2
              translate         ( AlturaSegundoSoporte
                        +AltoSoporte+1.5*DiametroDecorativo )*y
            }
            #local LargoBasicoSweep     = AltoBaseCuadrado
                -AlturaSegundoSoporte-AltoSoporte-2*DiametroDecorativo;
            #local FactorFinalSweep     = 0.3;
            #local FactorXSweep         = 1.2;
            #if ( EHEV_POV3_1 )
             
              cylinder        {
                      -FactorXSweep*DiametroBasicoPata/2*x,
           +( LargoBasicoSweep-FactorFinalSweep*DiametroBasicoPata/2 )*y,
                        DiametroBasicoPata/2
              translate ( AlturaSegundoSoporte
                        +AltoSoporte+2*DiametroDecorativo )*y
                        +FactorXSweep*DiametroBasicoPata/2*x
              }
              
            #else
            sphere_sweep        {
              cubic_spline
              4 ,
           -( LargoBasicoSweep-FactorFinalSweep*DiametroBasicoPata/2 )*y,           
                        FactorFinalSweep*DiametroBasicoPata/2,
              -FactorXSweep*DiametroBasicoPata/2*x,
                        DiametroBasicoPata/2,
           +( LargoBasicoSweep-FactorFinalSweep*DiametroBasicoPata/2 )*y,
                        FactorFinalSweep*DiametroBasicoPata/2,
              +FactorXSweep*DiametroBasicoPata/2*x,
                        DiametroBasicoPata/2
              translate ( AlturaSegundoSoporte
                        +AltoSoporte+2*DiametroDecorativo )*y
                        +FactorXSweep*DiametroBasicoPata/2*x
            }
            #end
            texture     { Textura1 }
          }
          object        {
            // se cambio union por object
            // pues solo tiene un objeto warning...
          
            cylinder      {
              ( AlturaPrimerSoporte+2*DiametroDecorativo+AltoSoporte )*y, 
              ( AlturaSegundoSoporte-DiametroDecorativo )*y     ,
              DiametroBasicoPata/2
            }
            texture       { Textura2 }
          }
        }
      #end  
         
      union     {
        #local PuntoVidrio      = 
                sqrt( 2 )/2*< LadoVerticeVidrio, LadoVerticeVidrio >;
        prism           {
          cubic_spline
          AltoBaseCuadrado      ,
          AltoBaseCuadrado+GruesoVidrio ,
          7                     ,
          PuntoVidrio,
          PuntoVidrio*<1,-1>,
          PuntoVidrio*<-1,-1>,
          PuntoVidrio*<-1,1>,
          PuntoVidrio,
          PuntoVidrio*<1,-1>,
          PuntoVidrio*<-1,-1>
          material   {
            Material1
          }
          rotate        Param1*y
          translate     Param2*<1,0,1>
        }
        
        #local PuntoTiraRectangular     = 
                < LadoBaseCuadrado/2, AltoSoporte, GruesoSoporte/2 >;
        #local C        = 0;
        #while ( C < 4 )
          object        {
            PataEsquineroVidrio()
            translate   +sqrt( 2 )*LadoBaseCuadrado/2*x
            rotate      ( 45+C*90 )*y
          }
          
          box           {
            PuntoTiraRectangular*<-1,0,-1>,
            PuntoTiraRectangular
            translate   -LadoBaseCuadrado/2*z+AlturaPrimerSoporte*y
            rotate      90*C*y
            texture     { Textura1 }
          }
          box           {
            PuntoTiraRectangular*<-1,0,-1>,
            PuntoTiraRectangular
            translate   -LadoBaseCuadrado/2*z+AlturaSegundoSoporte*y
            rotate      90*C*y
            texture     { Textura1 }
          }
          #local C      = C+1;
        #end
      }   
      #declare EHEV_TotalPisos  = 1;
      #declare EHEV_AlturaPisos         = array [ EHEV_TotalPisos ]
      #declare EHEV_AlturaPisos[ 0 ]    = AltoBaseCuadrado+GruesoVidrio;
    #break
    #case ( EHEV_VidrioDobleAlto )
      #local SeparacionEstante          = 300*L;
      #local RadioEstante               = 360*L;
      #local GruesoVidrio               = 3*L;
      #local ExcesoVidrioAire           = 1*L;
      #local ExcesoMadera               = 
                ( Param1-GruesoVidrio-ExcesoVidrioAire )/2;
      #local DiametroTotalMadera        = 
                        2*ExcesoMadera+GruesoVidrio+ExcesoVidrioAire;
  
      union     {
        #local C                        = 0;
        #while ( C < Param2 )
          object  {
            EHEV_EsquineroBasico( RadioEstante, GruesoVidrio,
                ExcesoVidrioAire, ExcesoMadera,
                Textura1, Textura2, Material1 ) 
            translate     C*SeparacionEstante*y                
          }
          #local C                      = C+1;
        #end
      }
      #declare EHEV_TotalPisos  = Param2; 
      #declare EHEV_AlturaPisos = array [ EHEV_TotalPisos ]
      #local C                  = 0;
      #while ( C < Param2 )
        #declare EHEV_AlturaPisos[ C ]           = 
                C*SeparacionEstante+ExcesoMadera+GruesoVidrio;
        #local C        = C+1;                
      #end
    #break
  #end
#end
 
#macro EHEV_EsquineroMetalTriple ()
  object        {
    #local L                      = 0.001;
    #local PisosExtra             = 0;
    #local RadioEsquinero         = 215*L;
    EHEV_EsquineroHogarEspacioVacio
                      ( EHEV_MetalTriple, 
                        RadioEsquinero,
                        PisosExtra, 
                        EHEV_TexturaMetalTriple, 
                        EHEV_TexturaSMetalTriple, 
                        EHEV_VidrioMetalTriple )
  }
#end

#macro EHEV_EsquineroPlasticoTriple ()   
  object        {
    #local L                      = 0.001;
    #local TotalPisos             = 3;
    #local DiametroPrincipal      = 260*L;
    EHEV_EsquineroHogarEspacioVacio
                        ( EHEV_PlasticoTriple,
                          DiametroPrincipal,
                          TotalPisos,
                          EHEV_TexturaPlasticoTriple,
                          EHEV_TexturaPatasPlasticoTriple,
                          EHEV_MaterialPlasticoTriple )                        
  }
#end 

#macro EHEV_EsquineroVidrioPisoSimple ()  
  object        {
    #local L              = 0.001;
    EHEV_EsquineroHogarEspacioVacio
                        ( EHEV_VidrioPisoSimple,
                          0,
                          <0,0,0>*L,
                          EHEV_TexturaDoradaVidrioPisoSimple,
                          EHEV_TexturaNegraVidrioPisoSimple,
                          EHEV_MaterialVidrioPisoSimple )                        
  }
#end

#macro EHEV_EsquineroVidrioDobleAlto ( BanderaAlto )
  #local L              = 0.001;
  #local DiametroMadera = 32*L;
  #local NumeroBases    = 2;
  #local AltoEstante    = 875*L;
  object        {
    EHEV_EsquineroHogarEspacioVacio
                        ( EHEV_VidrioDobleAlto,
                          DiametroMadera,
                          NumeroBases,
                          EHEV_TexturaSoporteVidrioDobleAlto,
                          EHEV_TexturaEsferaVidrioDobleAlto,
                          EHEV_MaterialVidrioDobleAlto )
    #if ( BanderaAlto )
      translate         AltoEstante*y
      #local C                  = 0;
      #while ( C < NumeroBases )
        #declare EHEV_AlturaPisos[ C ]           = 
                EHEV_AlturaPisos[ C ]+AltoEstante;
        #local C        = C+1;                
      #end
    #end
  }
#end