// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 27 setiembre 2010
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El objeto EscritorioBibliteca se coloca
// centrado en X+, la parte posterior inferior centrada en el origen
// Dimensiones : 930*L en X, 1260*L en Y y 430*L en z
//
// es puede modificar con la macro
// EBTU_EscritorioBibliotecaMov( G1, G2, G3, G4, G5, G6, GC, VI, VD )
// G1 : Gaveta Izquierda Arriba [0..1] 0 cerrado 1 abierto 70% aprox.
// G2 : Gaveta Izquierda Centro [0..1] 0 cerrado 1 abierto 70% aprox.
// G3 : Gaveta Izquierda Abajo  [0..1] 0 cerrado 1 abierto 70% aprox.
// G4 : Gaveta Derecha   Arriba [0..1] 0 cerrado 1 abierto 70% aprox.
// G5 : Gaveta Derecha   Centro [0..1] 0 cerrado 1 abierto 70% aprox.
// G6 : Gaveta Derecha   Abajo  [0..1] 0 cerrado 1 abierto 70% aprox.
// GC : Gaveta Centro           [0..1] 0 cerrado 1 abierto 70% aprox.
// VI : Vidrio Izquierdo        [0..1] 0 sin mover 1 corrido a la derecha
// VD : Vidrio Derecho          [0..1] 0 sin mover 1 corrido a la izquierda
// en todas las opciones anteriores
// -1 elimina el elemento
//
// Para colocarlo simplemente 
// object { EBTU_EscritorioBiblioteca }
// o bien, la macro siguiente...
// object { EBTU_EscritorioBibliotecaMov(0,0,0,0.1,0.2,1,1,0,0) }
// se pueden crear las gavetas con
// objetos y macros
// el objeto aparece con el frente orientado hacia z-, 
// de forma que descansa en el plano xz, y no necesita
// traslacin en z para colocarse en la biblioteca.
// object { EBTU_GavetaCentral }
// object { EBTU_GavetaLateral }
// object { EBTU_GavetaBiblioteca(Frente,Alto,FactorManija) }
// Frente : define el tamano del frente
// Alto   : define el alto ( la profundidad es la misma de la Biblioteca)
// FactorManija : 1 para EBTU_GavetaLateral, es un factor de escala
//                vale 0.75 para EBTU_GavetaCentral
// las gavetas pueden colocarse en posicion original con
// variables EBTU_TrasladarGavetaX, con X = 1,2,3,4,5,6 o C
// por ejemplo...
// union {
//   EBTU_EscritorioBibliotecaMov(-1,0,0,0,0,0,0,0,0)
//                 /*la opcion -1 elimina la gaveta de la macro*/
//   object     {
//     EBTU_GavetaLateral
//     translate EBTU_TrasladarGaveta1
//   }
// }
// En caso de aplicarse apertura, EBTU_TrasladarGavetaX incluye dicha
// apertura.
// algunas datos declarados con la macro utiles  
// EBTU_AltoNivelInferior       = altura del Estante1
// EBTU_AltoNivelVidrio         = altura de los objetos vidrio
// EBTU_AltoEstante3            = altura de los objetos en Estante3 
// EBTU_AltoSuperior            = altura total del objeto
// EBTU_ProfundidadSup          = profundidad total de la parte superior
// EBTU_PisoGavetaLateral       = alto del piso interior en gaveta lateral
// EBTU_PisoGavetaCentral       = alto del piso interior en gaveta central
// Estos son los modificadores permitidos en la unidad,
// si se utilizan deberan declararse antes del include respectivo.
// #declare EBTU_MaderaPrinc    = texture { ... }
// #declare EBTU_MaderaBarata   = texture { ... }
// #declare EBTU_TexturaVidrio  = texture { ... } 
// #declare EBTU_TexturaManija  = texture { ... }      
//

#include "colors.inc"
#include "woods.inc"
#include "textures.inc"
#include "glass.inc"

#ifndef ( EBTU_MaderaPrinc )
  #declare EBTU_MaderaPrinc    = texture       {
    T_Wood28
    scale       10
    rotate      145
  }
#end

#ifndef ( EBTU_MaderaBarata )
  #declare EBTU_MaderaBarata   = texture       {
    T_Wood23
    scale       30
    rotate      90
  }
#end
        
// EBTU_PanelCurvo
// queda el vertice en 0 y la figura orientada hacia 1,1,-1
// el vertice redondeado hacia z-
// AltoPanel indica altura de la madera
// eltrozo medira x*y*z MaderaDelgada*AltoPanel*ProfundidadCurva
#macro EBTU_PanelCurvoMitad( AltoPanel )
#local   L                      = 0.001;
#local   MaderaDelgada          = 7*L;
#local   MaderaMediana          = 10*L;
#local   MaderaGruesa           = 14*L;
#local   ProfundidadCurva       = 200*L;
  difference    {
     box        {
       -0.5,
       0.5
     }
    prism      {
       linear_sweep
       cubic_spline
       -0.6, 0.6,
       10,
       <100,0  >,
       <-0.5,1 >,
       <0,1/2>,
       <0.5,1/6>,
       <0,-1/6>,
       <0.5,-1/2>,
       <1,-1  >,
       <100,0  >,
       <-0.5,1 >,
       <0,1/2>
       scale    <14/186,1,1>
     }
     rotate     90*x
     translate  0.5
     texture       {
        EBTU_MaderaPrinc
     }
     scale      <ProfundidadCurva/(0.5*(1+14/186)),0.5*AltoPanel,MaderaDelgada>     
     rotate     90*y
     translate  -MaderaDelgada/2*x-MaderaDelgada/99*z
  }
#end

#macro EBTU_PanelCurvo( AltoPanel )
  union         {
    object      {
      EBTU_PanelCurvoMitad( AltoPanel )
    }
    object      {
      EBTU_PanelCurvoMitad( AltoPanel )
      rotate    180*z
    }
    translate   AltoPanel/2*y
  }
#end

#macro EBTU_GavetaBiblioteca( FrenteGaveta, AltoGaveta, EscalaManija )
#local   L                      = 0.001;
#local   MaderaDelgada          = 7*L;
#local   MaderaMediana          = 10*L;
#local   MaderaGruesa           = 14*L;
#local   ProfundidadNivelInferior               = 430*L;
#local   ProfundidadCurva       = 200*L;
  #local MaderaGaveta   = MaderaDelgada*1.5;
  union         {
    difference  {
      box         {
        <-FrenteGaveta/2,0,-ProfundidadNivelInferior+MaderaDelgada>,
        <FrenteGaveta/2,AltoGaveta*0.8,-MaderaMediana>
      }
      box         {
        <-FrenteGaveta/2+MaderaGaveta,-0.1*MaderaDelgada,
        -ProfundidadNivelInferior>,
        <FrenteGaveta/2-MaderaGaveta,0.1*AltoGaveta,
                -MaderaMediana-MaderaGaveta>
      }
      box       {
        <-FrenteGaveta/2+MaderaGaveta,0.1*AltoGaveta+MaderaGaveta,
                -ProfundidadNivelInferior>,
        <+FrenteGaveta/2-MaderaGaveta,AltoGaveta+MaderaDelgada,
                -MaderaMediana-MaderaGaveta>
      }
      texture   {
        EBTU_MaderaBarata
      }
    }
    union       {
      box       {
        <-FrenteGaveta/2,0,-ProfundidadNivelInferior>,
        <+FrenteGaveta/2,AltoGaveta,-ProfundidadNivelInferior+MaderaGaveta>
        texture {
          EBTU_MaderaPrinc
        }
      }
      lathe     {
        quadratic_spline
        6,
        < 0.6, -0.2 >,
        < 0.7,  0.0 >,
        < 0.6,  0.5 >,
        < 2.0,  1.2 >,
        < 1.8,  1.5 >,
        < 0  ,  2.0 >
        scale    MaderaGaveta*EscalaManija
        rotate     -90*x
        translate  <0,AltoGaveta/2,-ProfundidadNivelInferior> 
        texture { 
          #ifndef ( EBTU_TexturaManija )
            DMFWood6 
          #else
            EBTU_TexturaManija
          #end  
        }
      }
    }
  }
#end

#declare   EBTU_GavetaLateral  = object        {
#local   L                      = 0.001;
#local   MaderaMediana          = 10*L;
#local   FrenteEscritorio       = 930*L;
#local   AltoNivelInferior      = 535*L;   
#local   VacioInferiorLateral   = 75*L;
#local   ProfundidadNivelInferior               = 430*L;
#local   FrenteGaveteroCentral  = 350*L;
#local   FrenteGaveteroLateral  =
        (FrenteEscritorio-FrenteGaveteroCentral)/2-2*MaderaMediana;
#local   AltoGaveteroLateral    = AltoNivelInferior
        -VacioInferiorLateral-2*MaderaMediana;
  EBTU_GavetaBiblioteca(FrenteGaveteroLateral,AltoGaveteroLateral/3,1.0)
}

#declare   EBTU_GavetaCentral  = object        {
#local   L                      = 0.001;
#local   MaderaMediana          = 10*L;
#local   AltoNivelInferior      = 535*L;
#local   FrenteGaveteroCentral  = 350*L;
#local   FrenteGaveteroLateral  =
        (FrenteEscritorio-FrenteGaveteroCentral)/2-2*MaderaMediana;
#local   VacioInferiorCentral   = 420*L;
#local   BordeInferiorGaveteroCentral           = 28*L;
#local   AltoGaveteroCentral    = AltoNivelInferior-VacioInferiorCentral
        -BordeInferiorGaveteroCentral-MaderaMediana;
  EBTU_GavetaBiblioteca(FrenteGaveteroCentral,AltoGaveteroCentral,0.75)
}

#macro EBTU_EscritorioBibliotecaMov(G1,G2,G3,G4,G5,G6,GC,VI,VD)
#local Cubito         = box   {
        0,      1
  texture       {
    EBTU_MaderaPrinc
  }
}

// el escritorio tiene de alto
// AltoNivelSuperior+AltoNivelInferior+MaderaMediana (tope)
#local   L                      = 0.001;
#local   MaderaDelgada          = 7*L;
#local   MaderaMediana          = 10*L;
#local   MaderaGruesa           = 14*L;
#local   ProfundidadCurva       = 200*L;
#local   FrenteEscritorio       = 930*L;
#local   AltoNivelSuperior      = 715*L;
#local   AltoEstante1           = 286*L;
#local   AltoEstante3           = 197*L;
#local   AltoEstante2           = AltoNivelSuperior-AltoEstante1-AltoEstante3;
#local   AltoNivelInferior      = 535*L;
#local   ProfundidadNivelInferior               = 430*L;
// Los Frentes de Gavetero no incluyen la madera de lados en MaderaMediana
#local   FrenteGaveteroCentral  = 350*L;
#local   FrenteGaveteroLateral  =
        (FrenteEscritorio-FrenteGaveteroCentral)/2-2*MaderaMediana;
#local   VacioInferiorCentral   = 420*L;
#local   BordeInferiorGaveteroCentral           = 28*L;
#local   AltoGaveteroCentral    = AltoNivelInferior-VacioInferiorCentral
        -BordeInferiorGaveteroCentral-MaderaMediana;
#local   VacioInferiorLateral   = 75*L;
#local   AltoGaveteroLateral    = AltoNivelInferior
        -VacioInferiorLateral-2*MaderaMediana;
#local   AnchoCentralEstante2   = 286*L;
#declare EBTU_AltoNivelInferior = AltoNivelInferior;
#declare EBTU_AltoNivelVidrio   = AltoNivelInferior+AltoEstante1+MaderaDelgada;
#declare EBTU_AltoEstante3      = AltoNivelInferior+
                        AltoNivelSuperior-AltoEstante3; 
#declare EBTU_AltoSuperior      = AltoNivelInferior+AltoNivelSuperior;
#declare EBTU_ProfundidadSup    = ProfundidadCurva;
#declare EBTU_TrasladarGaveta1       =
  <-FrenteEscritorio/2+FrenteGaveteroLateral/2+MaderaMediana,
  AltoNivelInferior-MaderaMediana-AltoGaveteroLateral/3,0>;
#declare EBTU_TrasladarGaveta2       =
  <-FrenteEscritorio/2+FrenteGaveteroLateral/2+MaderaMediana,
  AltoNivelInferior-MaderaMediana-2*AltoGaveteroLateral/3,0>;
#declare EBTU_TrasladarGaveta3       =
  <-FrenteEscritorio/2+FrenteGaveteroLateral/2+MaderaMediana,
  AltoNivelInferior-MaderaMediana-AltoGaveteroLateral,0>;
#declare EBTU_TrasladarGaveta4       =
  <+FrenteEscritorio/2-FrenteGaveteroLateral/2-MaderaMediana,
  AltoNivelInferior-MaderaMediana-AltoGaveteroLateral/3,0>;
#declare EBTU_TrasladarGaveta5       =
  <+FrenteEscritorio/2-FrenteGaveteroLateral/2-MaderaMediana,
  AltoNivelInferior-MaderaMediana-2*AltoGaveteroLateral/3,0>;
#declare EBTU_TrasladarGaveta6       =
  <+FrenteEscritorio/2-FrenteGaveteroLateral/2-MaderaMediana,
  AltoNivelInferior-MaderaMediana-AltoGaveteroLateral,0>;
#declare EBTU_TrasladarGavetaC       =
  <0,AltoNivelInferior-MaderaMediana-AltoGaveteroCentral,0>;    
#declare EBTU_PisoGavetaLateral      =
        0.1*AltoGaveteroLateral/3+1.5*MaderaDelgada;   
#declare EBTU_PisoGavetaCentral      =
        0.1*AltoGaveteroCentral+1.5*MaderaDelgada;   
#local   MaximaAberturaGaveta   = ProfundidadNivelInferior*0.7;
// FactorVidrio es el Frente del vidrio de Estante2
// respecto al FrenteEscritorio
#local   FactorVidrio           = 0.5;
#local   MaximoDesplazamientoVidrio     =
        FrenteEscritorio-2*MaderaGruesa-2*MaderaDelgada
        -FactorVidrio*FrenteEscritorio;
union         {
   difference   {
     object       {
       Cubito
       scale
         < FrenteEscritorio-2*MaderaGruesa, AltoNivelSuperior,2*MaderaMediana>
       translate
         <-FrenteEscritorio/2+MaderaGruesa, AltoNivelInferior,-MaderaMediana>
     }
     object       {
       Cubito
       scale
         < FrenteEscritorio+2*MaderaMediana,
                AltoNivelInferior+AltoNivelSuperior+2*MaderaMediana,
                2*MaderaMediana>
       translate
         <-FrenteEscritorio/2-MaderaMediana, -MaderaDelgada/100, -MaderaDelgada/100 >
       texture  { EBTU_MaderaBarata }
     }
   }
   object       {
     Cubito
     scale
       < FrenteEscritorio-2*MaderaGruesa, MaderaMediana, ProfundidadCurva >
     translate  <-FrenteEscritorio/2+MaderaGruesa,
        AltoNivelInferior+AltoNivelSuperior,-ProfundidadCurva>
   }
   union        {
     object       {
       EBTU_PanelCurvo(AltoEstante1)
       translate  (-FrenteEscritorio/2+MaderaGruesa+MaderaDelgada/2)*x
     }
     object       {
       EBTU_PanelCurvo(AltoEstante1)
       translate  (+FrenteEscritorio/2-MaderaGruesa-MaderaDelgada/2)*x
     }
     object       {
       EBTU_PanelCurvo(AltoEstante1)
     }
     translate  AltoNivelInferior*y
   }
   union        {
     object       {
       EBTU_PanelCurvo(AltoEstante3)
       translate  (-FrenteEscritorio/2+MaderaGruesa+MaderaDelgada/2)*x
     }
     object       {
       EBTU_PanelCurvo(AltoEstante3)
       translate  (+FrenteEscritorio/2-MaderaGruesa-MaderaDelgada/2)*x
     }
     object       {
       EBTU_PanelCurvo(AltoEstante3)
     }
     translate  (AltoNivelInferior+AltoNivelSuperior-AltoEstante3)*y
   }
   union        {
     difference {
       object   {
         Cubito
         scale
                < FrenteEscritorio,AltoNivelInferior,ProfundidadNivelInferior>
         translate
                <-FrenteEscritorio/2,0,-ProfundidadNivelInferior>
       }
       object       {
         Cubito
         scale
           < FrenteEscritorio+2*MaderaMediana,
                AltoNivelInferior+AltoNivelSuperior+2*MaderaMediana,
                2*MaderaMediana>
         translate
           <-FrenteEscritorio/2-MaderaMediana, -MaderaDelgada/100, -MaderaDelgada/100 >
         texture  { EBTU_MaderaBarata }
       }
       object   {
         Cubito
         scale  < FrenteGaveteroCentral,
                        AltoGaveteroCentral, ProfundidadNivelInferior >
         translate      <-FrenteGaveteroCentral/2,
                        AltoNivelInferior-AltoGaveteroCentral-MaderaMediana,
                        -ProfundidadNivelInferior-MaderaMediana >
       }
       object   {
         Cubito
         scale  < FrenteGaveteroCentral,
                        AltoNivelInferior, ProfundidadNivelInferior >
         translate      <-FrenteGaveteroCentral/2,
             -AltoGaveteroCentral-MaderaMediana-BordeInferiorGaveteroCentral,
                        -ProfundidadNivelInferior-MaderaMediana>
       }
       object   {
         Cubito
         scale  < FrenteGaveteroLateral,
                        AltoGaveteroLateral, ProfundidadNivelInferior >
         translate <-FrenteEscritorio/2+MaderaMediana,
                        VacioInferiorLateral+MaderaMediana,
                        -ProfundidadNivelInferior-MaderaMediana>
       }
       object   {
         Cubito
         scale  < FrenteGaveteroLateral,
                        AltoGaveteroLateral, ProfundidadNivelInferior >
         translate < FrenteEscritorio/2-MaderaMediana-FrenteGaveteroLateral,
                        VacioInferiorLateral+MaderaMediana,
                        -ProfundidadNivelInferior-MaderaMediana>
       }
       object   {
         Cubito
         scale  < FrenteGaveteroLateral,
                        AltoNivelInferior, ProfundidadNivelInferior >
         translate <-FrenteEscritorio/2+MaderaMediana,
                        VacioInferiorLateral-AltoNivelInferior,
                        -ProfundidadNivelInferior-MaderaMediana>
       }
       object   {
         Cubito
         scale  < FrenteGaveteroLateral,
                        AltoNivelInferior, ProfundidadNivelInferior >
         translate < FrenteEscritorio/2-MaderaMediana-FrenteGaveteroLateral,
                        VacioInferiorLateral-AltoNivelInferior,
                        -ProfundidadNivelInferior-MaderaMediana>
       }
       #if ( VacioInferiorLateral = 0 )
       #else
         #local AltoCilindroBorrar      = 70*VacioInferiorLateral/75;
         #local AnchoCilindroBorrar     = 280*ProfundidadNivelInferior/430;
         #local RadioCilindroBorrar     = AltoCilindroBorrar/2+
                  AnchoCilindroBorrar*AnchoCilindroBorrar
                  /(8*AltoCilindroBorrar);
         cylinder       {
           -FrenteEscritorio*x,
           +FrenteEscritorio*x,
           RadioCilindroBorrar
           translate    <0,-RadioCilindroBorrar+AltoCilindroBorrar,
                                -ProfundidadNivelInferior/2>
         }
       #end
     }
   }
   union        {
     difference {
       object   {
         Cubito
         scale
           < FrenteEscritorio-2*MaderaGruesa, AltoEstante2, ProfundidadCurva >
         translate        <-FrenteEscritorio/2+MaderaGruesa,
                        AltoNivelInferior+AltoEstante1,
                        -ProfundidadCurva >
       }
       object       {
         Cubito
         scale
           < FrenteEscritorio+2*MaderaMediana,
                AltoNivelInferior+AltoNivelSuperior+2*MaderaMediana,
                2*MaderaMediana>
         translate
           <-FrenteEscritorio/2-MaderaMediana, -MaderaDelgada/100, -MaderaDelgada/100 >
         texture  { EBTU_MaderaBarata }
       }
       object   {
         Cubito
         scale  < FrenteEscritorio-2*MaderaGruesa-2*MaderaDelgada,
                AltoEstante2-2*MaderaDelgada, ProfundidadCurva >
         translate        <-FrenteEscritorio/2+MaderaGruesa+MaderaDelgada,
                        AltoNivelInferior+AltoEstante1+MaderaDelgada,
                        -ProfundidadCurva-MaderaMediana >
       }
     }
   }
   object       {
     Cubito
     scale      < MaderaDelgada,AltoEstante2-MaderaDelgada,
                ProfundidadCurva-MaderaDelgada*105/100-MaderaMediana>
     translate  < -AnchoCentralEstante2/2-MaderaDelgada,
                AltoNivelInferior+AltoEstante1+MaderaDelgada/2,
                -ProfundidadCurva+MaderaDelgada+MaderaMediana>
   }
   object       {
     Cubito
     scale      < MaderaDelgada,AltoEstante2-MaderaDelgada,
                ProfundidadCurva-MaderaDelgada*105/100-MaderaMediana>
     translate  < AnchoCentralEstante2/2,
                AltoNivelInferior+AltoEstante1+MaderaDelgada/2,
                -ProfundidadCurva+MaderaDelgada+MaderaMediana>
   }
   object       {
     Cubito
     scale      < FrenteEscritorio-2*MaderaMediana-2*MaderaDelgada,
                MaderaMediana, MaderaMediana>
     translate  <-FrenteEscritorio/2+MaderaMediana+MaderaDelgada,
                AltoNivelInferior+AltoEstante1+MaderaDelgada,
                -ProfundidadCurva+MaderaDelgada>
   }
   object       {
     Cubito
     scale      < FrenteEscritorio-2*MaderaMediana-2*MaderaDelgada,
                MaderaMediana, MaderaMediana>
     translate  <-FrenteEscritorio/2+MaderaMediana+MaderaDelgada,
      AltoNivelInferior+AltoEstante1+AltoEstante2-MaderaDelgada-MaderaMediana,
                -ProfundidadCurva+MaderaDelgada>
   }
   #if (G1 = -1)
   #else
     object     {
       EBTU_GavetaLateral
       translate        EBTU_TrasladarGaveta1
       translate        -G1*MaximaAberturaGaveta*z
       #declare EBTU_TrasladarGaveta1   =
                        EBTU_TrasladarGaveta1-G1*MaximaAberturaGaveta*z;
     }
   #end
   #if (G2 = -1)
   #else
     object     {
       EBTU_GavetaLateral
       translate        EBTU_TrasladarGaveta2
       translate        -G2*MaximaAberturaGaveta*z  
       #declare EBTU_TrasladarGaveta2   =
                        EBTU_TrasladarGaveta2-G2*MaximaAberturaGaveta*z;
     }
   #end
   #if (G3 = -1)
   #else
     object     {
       EBTU_GavetaLateral
       translate        EBTU_TrasladarGaveta3
       translate        -G3*MaximaAberturaGaveta*z
       #declare EBTU_TrasladarGaveta3   =
                        EBTU_TrasladarGaveta3-G3*MaximaAberturaGaveta*z;
     }
   #end
   #if (G4 = -1)
   #else
     object     {
       EBTU_GavetaLateral
       translate        EBTU_TrasladarGaveta4
       translate        -G4*MaximaAberturaGaveta*z
       #declare EBTU_TrasladarGaveta4   =
                        EBTU_TrasladarGaveta4-G4*MaximaAberturaGaveta*z;
     }
   #end
   #if (G5 = -1)
   #else
     object     {
       EBTU_GavetaLateral
       translate        EBTU_TrasladarGaveta5
       translate        -G5*MaximaAberturaGaveta*z
       #declare EBTU_TrasladarGaveta5   =
                        EBTU_TrasladarGaveta5-G5*MaximaAberturaGaveta*z;
     }
   #end
   #if (G6 = -1)
   #else
     object     {
       EBTU_GavetaLateral
       translate        EBTU_TrasladarGaveta6
       translate        -G6*MaximaAberturaGaveta*z
       #declare EBTU_TrasladarGaveta6   =
                        EBTU_TrasladarGaveta6-G6*MaximaAberturaGaveta*z;
     }
   #end
   #if (GC = -1)
   #else
     object     {
       EBTU_GavetaCentral
       translate        EBTU_TrasladarGavetaC
       translate        -GC*MaximaAberturaGaveta*z
       #declare EBTU_TrasladarGavetaC   =
                        EBTU_TrasladarGavetaC-GC*MaximaAberturaGaveta*z;
     }
   #end
   #if (VI=-1)
   #else
     box                {
       0, 1
       scale      < FrenteEscritorio*FactorVidrio,
                AltoEstante2-2*MaderaDelgada, MaderaMediana/5>
       translate  <-FrenteEscritorio/2+MaderaGruesa+MaderaDelgada
                +VI*MaximoDesplazamientoVidrio,
                AltoNivelInferior+AltoEstante1+MaderaDelgada,
                -ProfundidadCurva+MaderaDelgada+MaderaMediana/5>
       texture    { 
         #ifndef ( EBTU_TexturaVidrio )
           T_Glass3
         #else
           EBTU_TexturaVidrio
         #end
       }
     }
   #end
   #if (VD=-1)
   #else
     box                {
       0, 1
       scale      < FrenteEscritorio*FactorVidrio,
                AltoEstante2-2*MaderaDelgada, MaderaMediana/5>
       translate  <-FrenteEscritorio/2+MaderaGruesa+MaderaDelgada
                +(1-VD)*MaximoDesplazamientoVidrio,
                AltoNivelInferior+AltoEstante1+MaderaDelgada,
                -ProfundidadCurva+MaderaDelgada+3*MaderaMediana/5>
       texture    {
         #ifndef ( EBTU_TexturaVidrio )
           T_Glass3
         #else
           EBTU_TexturaVidrio
         #end
       }
     }
   #end
}
#end

#declare EBTU_EscritorioBiblioteca   = object        {
  EBTU_EscritorioBibliotecaMov(0.0,0.05,0.01,0.0,0.1,0.0,0.0,0.2,0.0)
}


