// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 27 setiembre 2010
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El objeto EscritorioBibliteca se coloca
// centrado en X+, la parte posterior inferior centrada en el origen
// Dimensiones : 930*L en X, 1260*L en Y y 430*L en z
//
// es puede modificar con la macro
// EBTU_EscritorioBibliotecaMov( G1, G2, G3, G4, G5, G6, GC, VI, VD )
// G1 : Gaveta Izquierda Arriba [0..1] 0 cerrado 1 abierto 70% aprox.
// G2 : Gaveta Izquierda Centro [0..1] 0 cerrado 1 abierto 70% aprox.
// G3 : Gaveta Izquierda Abajo  [0..1] 0 cerrado 1 abierto 70% aprox.
// G4 : Gaveta Derecha   Arriba [0..1] 0 cerrado 1 abierto 70% aprox.
// G5 : Gaveta Derecha   Centro [0..1] 0 cerrado 1 abierto 70% aprox.
// G6 : Gaveta Derecha   Abajo  [0..1] 0 cerrado 1 abierto 70% aprox.
// GC : Gaveta Centro           [0..1] 0 cerrado 1 abierto 70% aprox.
// VI : Vidrio Izquierdo        [0..1] 0 sin mover 1 corrido a la derecha
// VD : Vidrio Derecho          [0..1] 0 sin mover 1 corrido a la izquierda
// en todas las opciones anteriores
// -1 elimina el elemento
//
// Para colocarlo simplemente 
// object { EBTU_EscritorioBiblioteca }
// o bien, la macro siguiente...
// object { EBTU_EscritorioBibliotecaMov(0,0,0,0.1,0.2,1,1,0,0) }
// se pueden crear las gavetas con
// objetos y macros
// el objeto aparece con el frente orientado hacia z-, 
// de forma que descansa en el plano xz, y no necesita
// traslacin en z para colocarse en la biblioteca.
// object { EBTU_GavetaCentral }
// object { EBTU_GavetaLateral }
// object { EBTU_GavetaBiblioteca(Frente,Alto,FactorManija) }
// Frente : define el tamano del frente
// Alto   : define el alto ( la profundidad es la misma de la Biblioteca)
// FactorManija : 1 para EBTU_GavetaLateral, es un factor de escala
//                vale 0.75 para EBTU_GavetaCentral
// las gavetas pueden colocarse en posicion original con
// variables EBTU_TrasladarGavetaX, con X = 1,2,3,4,5,6 o C
// por ejemplo...
// union {
//   EBTU_EscritorioBibliotecaMov(-1,0,0,0,0,0,0,0,0)
//                 /*la opcion -1 elimina la gaveta de la macro*/
//   object     {
//     EBTU_GavetaLateral
//     translate EBTU_TrasladarGaveta1
//   }
// }
// En caso de aplicarse apertura, EBTU_TrasladarGavetaX incluye dicha
// apertura.
// algunas datos declarados con la macro utiles  
// EBTU_AltoNivelInferior       = altura del Estante1
// EBTU_AltoNivelVidrio         = altura de los objetos vidrio
// EBTU_AltoEstante3            = altura de los objetos en Estante3 
// EBTU_ProfundidadSup          = profundidad total de la parte superior
// EBTU_PisoGavetaLateral       = alto del piso interior en gaveta lateral
// EBTU_PisoGavetaCentral       = alto del piso interior en gaveta central
// Estos son los modificadores permitidos en la unidad,
// si se utilizan deberan declararse antes del include respectivo.
// #declare EBTU_MaderaPrinc    = texture { ... }
// #declare EBTU_MaderaBarata   = texture { ... }
// #declare EBTU_TexturaVidrio  = texture { ... }
//

#include "colors.inc"
#include "EscriBTU.inc"

#local OjoAbsoluto            = 256;
#local VecesCentroAbsoluto    = 10;     
#local L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

object          {
  EBTU_EscritorioBibliotecaMov(0.0,1.0,0.0,0.0,0.1,0.0,0.0,0.2,0.0)
  scale         0.7
  rotate        20*y
  translate     < 0, -0.5  , -0.5  >
}

