// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 7 Noviembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ADVERTENCIA:  Este es un borrador, creado para el juego
// de cubiertos, se conocen defectos...
// Es mejor que espere versiones posteriores de Bezier.inc y
// archivos include relacionados.
//
//
// Instrucciones de uso
// indice de macros y variables
// A. Funciones matematicas     {A1}
// B. Algunas convenciones      {B1}
// B. FSSK_ArBezierTextura[]    {C1}
// C. TotalFSSK_ArBezier        {D1} 
// D. FSSK_ArregloLaminado()         {E1}
// E. Macros de Ajuste interno  {F1}
//  
// {A1}
// { Utilidad general }
// FSSK_SplineLineaBezier (NuevoV, Pu, v0, v1, v2, v3 )
//    NuevoV: Output -> valor de la Spline Bezier como vector
//      definida como f(0)=v0 y f(1)=v3
//    Pu    : parametro Pu float variable
//    v0,v1,v2,v3       : vectores de control  
// FSSK_DerivadaSplineLineaBezier (NuevoV, Pu, v0, v1, v2, v3 )
//    NuevoV: Output -> valor de la PrimeraDerivada Spline Bezier 
//      como vector
//      definida por f(0)=v0 y f(1)=v3. La macro devueve f'(Pu)
//    Pu    : parametro Pu float variable
//    v0,v1,v2,v3       : vectores de control 
// { Funciones de intercambio de indices }
// De poco uso, pero pueden ser utiles en algunos algoritmos
// los indices de una matriz Bezier varian [0..3,0..3]
// FSSK_SimC( I )  = function
//   "simetria corta" convierte 0 <--> 1 y 2 <--> 3
// FSSK_SimL( I )  = function
//   "simetria larga" convierte 0 <--> 3 y 1 <--> 2
// FSSK_rotD( I )  = function
//   "rotacion derecha", sigue la secuencia 0 -> 1 -> 2 -> 3 -> 0...
// FSSK_rotI( I )  = function
//   "rotacion inversa"  sigue la secuencia 3 -> 0 -> 1 -> 2 -> 3..
// { Utilidades matematicos para manejo del tipo Bezier }
// #macro VerticeBezier ( NuevoV, NumeroCasilla, Vertice )
//     devuleve el vector en el Vertice
//   NuevoV        : output -> el vector solicitado
//   NumeroCasilla : indica el FSSK_ArBezier
//   Vertice       : numero que identifica el vertice, ver convenciones
// #macro FSSK_BordeBezier ( NuevoV, NumeroCasilla, Pu, NumeroLado )
//     obtiene un punto en uno de los bordes
//   NuevoV        : output -> el vector solicitado
//   NumeroCasilla : identifica el FSSK_ArBezier
//   Pu            : parametro que en el borde varia de 0 a 1
//   NumeroLado    : indica el borde, sigue la convencion
//     se recorre en el sentido usual
//         --->
//            *
//         <--v
// #macro FSSK_PSeudoNormalBezier ( NumeroCasilla, NuevoV )
//          Calcula una PseudoNormal de la lamina
//         en general el tipo Bezier, no tendra una normal unica verdadera
//         simplemente se estima como el producto cruz de la diferencia
//         de los vertices
//    NumeroCasilla : numero que identifica al Bezier
//    NuevoV        : output -> vector normal estimado
// { Utilidad especifica para el proceso }
// FSSK_UbicarNormalGuiaUnitaria 
//          ( NuevoV, Base, Referencia, NormalUnitaria, Intensidad )
//    NuevoV: Output -> Base mas la proyeccion de (Referencia-Base)
//          en la perpendicualar a NormalUnitaria, 
//          el desplazamiento se corrige con Intensidad
//    Base       : Punto de origen del sistema
//    Referencia : Punto a ser proyectado ( mismas coordenadas que Base )
//    NormalUnitaria : direccion de proyeccion a partir de Base,
//          debe ser unitaria, se establece la perpendicular
//          por diferencia con (Referencia-Base)
//    Intensidad     : el valor 1.0 es la proyeccion usual, se corrige
//          proporcionalmente, en la direccion de proyeccion
//   
// {B1}
// Cuando se especifica un Vertice se sigue el orden
//     0---1
//     /   /
//     3---2
// en la matriz Bezier.  
// Para lados, es un orden similar
//     *-0-*
//     3   1
//     *-2-*
// Sin embargo;  al introducir los puntos, se supone que se
// sigue el siguiente orden
//     0---1
//     /   /
//     3---2
// Puede cambiar la regla con 
//   #declare FSSK_BanderaReglaGiro     = false;
// si lo hace el orden de los puntos al introducir sera
//     0---1
//     /   / 
//     2---4 
//   unicamente afecta la macro de introduccion de cuatro puntos
//
// {C1}
// Pueden definirse los modificadores
// #declare FSSK_BezierTexturaDefault = texture {...}, 
//   para agregar a todos la misma textura por defecto
//   modificable con
// #FSSK_ArBezierTextura[ NumeroCasilla ]       = texture {...}
//   Por defecto la inicializacion de textura inicializa
//   el arreglo con colores al azar
//   puede evitarse cualquier inicializacion con
// #declare FSSK_InicializarTexturaDefault   = off;
//   pero esto tambien evita el pintado con la textura por defecto 
//   ademas existe un 
//   FSSK_ArBezierTipo que siempre se inicializa
//   con predefinible #declare FSSK_BezierTipoDefault = <color>;
//   es un arreglo de colores
//     red      -> on (BezierVisible), off (Bezierinactivo)
//     green    -> asigna el tipo de bicubicpath (se asigna a type)
//     blue     -> se asigna a u_steps
//     filter   -> se asigna a v_steps
//     transmit -> se asigna a flatness
//   el valor default <on,1,4,4,0>
// #declare FSSK_BanderaDebug = true;
//   que "escribe" en output usual, una lista
//   de los puntos y los FSSK_ArBezier existentes
//   en cada llamada a macro FSSK_ArregloLaminado() 
//
// {D1}
// #declare TotalFSSK_ArBezier  = 100;
//   Con valor predefinido de 100,
//   para inicializar varias variables
//   puede disminuirse su valor, o aumentarse de previo
//   si se requiere, para dar lugar a mas datos
//   cada dato se asume es un 
//   bicubicpath {...}, mas varios descriptores
//
// {E1}
// FSSK_ArregloLaminado()
//   es la macro que crea el conjunto Bezier sin parametros en el parentesis
//   podrian desactivarse algunos datos con
// #declare FSSK_ArBezierTipo[NumeroCasilla].red = off;
//   se dibujaran todos los arreglos con
//   NumeroCasilla < FSSK_DefinidoB
//   no olvidar que la numeracion de un array comienza en 0
//   por eso se recomienda crear el dato y luego aumetar FSSK_DefinidoB
//   ...CustomGeneraBicubic(FSSK_DefinidoB)
// #declare FSSK_DefinidoB      = FSSK_DefinidoB+1;
//   Ademas existe la variable false por defecto
// #declare FSSK_BanderaDebug       = true;
//     que al activarse suministra una lista de los FSSK_ArBezier activos,
//     en cada llamada a FSSK_ArregloLaminado.
// FSSK_ArregloLaminadoIF(Inicio,Fin) 
//   Misma funcion que FSSK_ArregloLaminado(), pero se indica
//   el valor inicial y final, para generar el objeto.
//   Puede llamarse varias veces, para generar objetos diferentes.   
//
// {F1}
// {UtilidadGeneral}
// #macro FSSK_IniciarCasillaBezier ( NumeroCasilla, Ver1, Ver2, Ver3, Ver4 )  
//     asigna un arreglo plano de puntos
//     no cambia el valor de FSSK_DefinidoB (leer FSSK_ArregloLaminado())
//   NumeroCasilla : identifica el FSSK_ArBezier
//   Ver1, Ver2, Ver3, Ver4 : secuencia de puntos
//     leer orden en seccion de "convenciones"
// #macro FSSK_AjusteBezierLateral ( NumeroCasilla, NumeroLado, Ajuste )
//     ajuste de una correccion por empuje de un borde
//     sin modificar los vertices, pero si "todos" los puntos centrales
//     en forma pesada para cada "lado", de forma
//     que al aplicar los cuatro lados, queden razonables.
//   NumeroCasilla : FSSK_ArBezier a modificar
//   NumeroLado    : indica el lado a modificar (leer convenciones)
//   Ajuste        : vector de empuje.  Se aplica completo al lado 
//     sin afectar vertices
//     pesado al centro, menor efecto con distancia. 
// #macro FSSK_AjusteBezierCentral ( NumeroCasilla, Ajuste, FactorAtraccion ) 
//     macro que afecta en forma homogenea los cuatro puntos centrales
//   NumeroCasilla : indica el FSSK_ArBezier a modificar
//   Ajuste        : vector para indicar el empuje
//   FactorAtraccion : antes de aplicar el empuje, el centro
//     se atrae hacia el Vertice FactorAtraccion 1.0 no "atrae",
//     a menores valores mas cercano al vertice.
//     La idea es que Ajuste probablemente sea perpendicular a un
//     "casi" plano Bezier, FactorAjuste se encargaria de
//     acercar cada punto central a su respectivo vertice si se desea.
// #macro FSSK_TransformBezier ( NumeroCasilla, FuncionTransform ) 
//     Aplica una FuncionTransform
//     a todos los puntos de un FSSK_ArBezier
//   NumeroCasilla : identifica el FSSK_ArBezier
//   FunctionTransform : function { transform {...} }, o spline
//     que actua sobre un vector3D y devuelve un vector3D
// #macro FSSK_GemeloBezier
//        ( NumeroCasilla, CasillaReferencia, HerenciaTextura )
//     Genera un "gemelo" del arreglo en CasillaReferencia
//     Nota: hereda puntos y quiza Herencia, no clasificacion
//     asi, que pueden copiarse arreglos "inactivos"
//   NumeroCasilla     : identifica el FSSK_ArBezier destino
//   CasillaReferencia : el identificador del FSSK_ArBezier molde
//   HerenciaTextura   : si true "hereda" la textura actual
//     caso contrario, no modifica (probable default...) 
// #macro FSSK_CorreccionBezierNormal( NumeroCasilla, Vertice, 
//      Normal, Intensidad1, Intensidad2, Intensidad3 )
//   Realiza una correccion en los tres puntos adyacentes a un vertice
//     de forma que los tres puntos queden perpendiculares a Normal
//     la proyeccion inmediata es intensidad 1.0
//     recuerde que en Bezier los puntos adyacentes definen la derivada
//     por tanto aplicando esta macro en todos los Bezier
//     pertinentes asegura la continuadad en el "Vertice" de grado 1
//     con otras macros podria asegurar la continuidad 0 en el borde
//     mas que eso esta unidad no brinda macros apropiadas
//   NumeroCasilla : identificador del Bezier pertinente
//   Vertice       : 0,1,2 o 3, define el vertice en matriz
//              0 superior izquierdo    1 superior derecho 
//              2 inferior derecho      3 inferior izquierdo
//   Normal        : define la normal (no necesita ser unitaria)
//   Intensidad1   : 1.0 es correccion usual, varia proporcionalmente
//              se define en la direccio anterior (ver clave de vertice)
//              sigue function FSSK_rotI(Vertice)
//   Intensidad2   : 1.0 es correccion usual, varia proporcionalmente
//              para corregir el punto "hacia" el centro
//   Intensidad3   : 1-0 es correccion usual, varia proporcionalmente
//              se define en la direccion siguiente FSSK_rotD(Vertice)
// #macro FSSK_AjusteBordesBezier ( NumeroCasilla, LadoCasilla, 
//                CasillaReferencia, LadoReferencia, BanderaInvertir )
//     Para calzar bordes entre dos placas Bezier y lograr
//     continuidad de grado 0.  Note que puede realizar con otras
//     macros desplazamientos de borde, sin perder continuidad 0.
//     Esta macro solo modifica el borde. Tenga cuidad de no perder
//     los puntos centrales.  Puede ayudarse con la macro 
//     FSSK_AplanarCentroBezier para reubicar los centros.
//   NumeroCasilla : Identifica la matriz a modificar para el ajuste
//   LadoCasilla   : Numero de lado a ajustar (convenciones usuales)
//   CasillaReferencia : Identifica la matriz Bezier que tiene el borde
//     que se usara de molde
//   LadoReferencia    : Numero para identificar el lado de referencia
//   BanderaInvertir   : la asignacion se realiza, asumiendo que
//     calzan como la grafica
//          
//                 un giro de       con algun giro de
//               
//               0,0      0,3       0,0      0,3
//                                                
// 
//               3,0      3,3       3,0      3,3
//     es decir; ambos arreglos tienen orientacio horaria o antihoraria
//     simultaneamente, se hace necesario una inversion
//     a la hora de calzar el limite
//     asi que en general hay
//     que asignar BanderaInvertir = true
//     Sin embargo, puede que en algun caso este supuesto produzca
//     que la asignacion quede mal, esto se corrige con 
//     BanderaInvertir = false
//     NOTA:  esto no se afecta por la bandera FSSK_BanderaReglaGiro
// #macro   FSSK_AplanarCentroBezier ( NumeroCasilla, BanderaHorizontal )
//     Realiza una correccion en los puntos centrales de la matriz
//     Bezier, esto puede ser util, por desajustes graves
//     Piense por ejemplo al ajustar curvas muy delgadas
//     es posible que los puntos centrales se salgan de la linea
//     esto puede corregirse con esta macro,
//     y si es necesario aplicar despues FSSK_AjusteBezierCentral
//     la ventaja de esta macro, es que se puede
//     ahorra el "calculo", del tamano del ajuste.
//   NumeroCasilla : identifica al arreglo de Bezier
//   BanderaHorizontal : se aplana en referencia a los bordes
//      si true se utilizan los bordes derecho e izquierdo
//      de matriz, si false, los bordes superior e inferior
// #macro FSSK_CompresionBezierHilera 
//        ( NumeroCasilla, Factor, Sentido, Hilera )
//     Esta macro realiza una compresion en una Hilera unicamente
//     guiado por sentido e Hilera
//   NumeroCasilla : indica el FSSK_ArBezier
//   Factor        : si 1.0 no pasa nada, el Factor sigue la interpolacion
//                      Bezier de 0 a 1... permite salir del limite
//   Sentido       : numero entre 0 a 1 para indicar la direccion
//                        0
//                        *
//                        ^           flecha en direccion de compresion
//                 3**<       >**1      en FSSK_ArBezier 
//                        V
//                        *
//                        2
//   Hilera        : la clave de Hilera de 0 a 3 es como sigue
//                       0 1 2 3
//                     3         0
//                     2         1  correspondiente a cada Sentido
//                     1         2
//                     0         3
//                       3 2 1 0
// #macro FSSK_CompresionBezier ( NumeroCasilla, Factor, Sentido )
//     Esta macro realiza una compresion en cierto sentido
//     del FSSK_ArBezier ( llama las 4 Hileras en 
//              FSSK_CompresionBezierHilera )
//   NumeroCasilla : identifica el FSSK_ArBezier
//   Factor        : si 1.0 no pasa nada, el factor sigue la interpolacion
//                      Bezier de 0 a 1... permite salir del limite
//   Sentido       : numero entre 0 a 1 para indicar la direccion
//                        0
//                        *
//                        ^           flecha en direccion de compresion
//                 3**<       >**1      en FSSK_ArBezier 
//                        V
//                        *
//                        2
// #macro FSSK_AjusteCurvoBezier ( NumeroCasilla, NumeroVertice, 
//                Intensidad, BanderaSimetrico, AjusteSimetrico )
//     La idea es crear bordes curvos planos, al estilo "mesa"
//     la macro se utiliza en estado plano para el Bezier
//     despues probablemente, no de buen resultado
//     el vertice en la matriz seria
//     0  Superior Izquierda        1  SuperiorDerecha
//     2  Inferior Derecho          3  InferiorIzquierda
//     Intensidad 1 es bastante curva hacia 0(prohibido) disminuye
//     la "fuerza" de la curva convirtiendose en cuadrado redondeado  
//     BanderaSimetrico si false crea una especie de elipse que
//     se puede redondear a rectangulo plano disminuyendo la intensidad
//     si true se activa AjusteSimetrico que es float
//     que se puede modificar para cambiar la intensidad en
//     ambos sentidos (recomendado 1.0), y lograr el efecto deseado  
//     si false BanderaSimetrico se ignora AjusteSimetrico
//   NumeroCasilla : indica el FSSK_ArBezier a modificar
//   NumeroVertice : vertide a curvar
//   Intensidad    : intensidad de la curva
//   BanderaSimetrico : si true se intenta igualar modificaciones en
//     ambos sentidos
//   AjusteSimetrico : valor para el ajuste en caso true BanderaSimetrico
// #macro FSSK_AsignarTexturaBezier ( NumeroCasilla, TexturaNueva )
//   NumeroCasilla : indica el FSSK_ArBezier
//   TexturaNueva  : texture {} a agregar a dicho arreglo
// #macro FSSK_SubdivisionMarcoPlanoBezier ( NumeroCasilla, HerenciaTextura )
//     divide un FSSK_ArBezier en cinco, el actual es el central
//     deberia aplicarse despues de aumentar FSSK_DefinidoB
//     si se trata del ultimo
//     Los otros cuatros incrementan automaticamente FSSK_DefinidoB
//     en el orden respecto de matriz.  Se podrian accesar asi...
//     FSSK_DefinidoB-4 = arriba
//     FSSK_DefinidoB-3 = derecha
//     FSSK_DefinidoB-2 = abajo
//     FSSK_DefinidoB-1 = izquierda
//     NumeroCasilla    = central
//     el central queda plano, segun los puntos centrales, que lo definen
//     los otros quedan aplanados, pero mantienen el borde que
//     corresponda segun el caso
//   NumeroCasilla : indica el FSSK_ArBezier
//   HerenciaTextura : si true hereda la textura, si false textura default
//     de la unidad o la que corresponda
// #macro   FSSK_LaminaBezier ( NumeroCasilla, Empuje, OpcionSteps )
//   Convierte una hoja simble Bezier en una lamina 3D de seis Bezier
//   FSSK_DefinidoB pasa a ser identico con translate Empuje,
//   las otras cuatro laminas simplemente cierran como un prisma
//   el bloque, (lateralmente son planas, pero conservan la curva )
//   en total FSSK_DefinidoB aumentara en "5"
//   asegurese que NumeroCasilla <> FSSK_DefinidoB de entrada,
//     FSSK_DefinidoB-5 = Gemelo trasladado
//     FSSK_DefinidoB-4 = lateral matriz superior
//     FSSK_DefinidoB-3 = lateral matriz derecho
//     FSSK_DefinidoB-2 = lateral matriz inferior
//     FSSK_DefinidoB-1 = lateral matriz izquierdo
//     NumeroCasilla    =  sin cambio
//   NumeroCasilla : Hoja Bezier a ser laminada
//   Empuje        : indica la traslacion que genera la lamina
//   OpcionSteps   : si negativo no hace nada, si positivo 
//     corrige u_steps y v_steps de los laterales segun el caso,
//     Por ejemplo:  si la lamina es delgada, es probable que
//     un borde plano "vertical" sea suficiente, 
//     en ese caso asigne OpcionSteps = 0
//     Se corrige el factor adecuado, conservando la curva del otro
//     parametro. 
//

#include "debug.inc" 

#declare FSSK_POV3_1                    = off;

#ifndef ( FSSK_BanderaDebug )
  #declare FSSK_BanderaDebug            = false;
#end                   
// por el momento sin uso                    
                    
#ifndef ( FSSK_TotalFSSK_ArBezier )
  #declare FSSK_TotalFSSK_ArBezier           = 100;
#end

#ifndef ( FSSK_BanderaReglaGiro )
  #declare FSSK_BanderaReglaGiro        = true;
#end

#declare FSSK_ArBezier          = array [FSSK_TotalFSSK_ArBezier][4][4];  
#declare FSSK_ArBezierTextura   = array [FSSK_TotalFSSK_ArBezier];  
#declare FSSK_ArBezierTipo      = array [FSSK_TotalFSSK_ArBezier];

#ifndef ( FSSK_BezierTipoDefault )
  #local   Tipo1                = 0;
  #local   U4                   = 4;
  #local   V4                   = 4;
  #local   Flat0                = 0;  
  #declare FSSK_BezierTipoDefault    = < on, Tipo1, U4, V4, Flat0 >;
#end
                              
#local   A    = 0;
#while ( A < FSSK_TotalFSSK_ArBezier )
   #declare FSSK_ArBezierTipo[ A ] = FSSK_BezierTipoDefault;
   #local A    = A+1;
#end
 
// modificacion de la macro en "strings.inc" 
#macro FSSK_Str(A)
    str(A, 5, 0)
#end

// modificacion de la macro en "strings.inc"
#macro FSSK_VStr(V)             
    concat("<", vstr(3, V, ",", 5,0), ">")
#end

#ifndef ( FSSK_InicializarTexturaDefault )
  #declare FSSK_InicializarTexturaDefault    = true;
#end
#if ( FSSK_InicializarTexturaDefault )
  #local   S    = seed(0);
  #local   A    = 0;
  #while ( A < FSSK_TotalFSSK_ArBezier )
    #declare FSSK_ArBezierTextura[ A ] = texture { 
      #ifndef ( FSSK_BezierTexturaDefault )
        pigment { color rgb < rand(S), rand(S), rand(S) > } 
      #else
        FSSK_BezierTexturaDefault
      #end  
    }
    #local A    = A+1;
  #end
#end

#declare FSSK_DefinidoB         = 0;

#local   A_C                            = 4/3;
#declare FSSK_ArregloFSSK_AjusteBezierLateral     = array [4][4][4]    
        {{{0,    1,    1,0},
          {0,A_C/3,A_C/3,0},
          {0,A_C/6,A_C/6,0},
          {0,    0,    0,0}},
         {{0,    0,    0,0},
          {0,A_C/6,A_C/3,1},
          {0,A_C/6,A_C/3,1},
          {0,    0,    0,0}},
         {{0,    0,    0,0},
          {0,A_C/6,A_C/6,0},
          {0,A_C/3,A_C/3,0},
          {0,    1,    1,0}},
         {{0,    0,    0,0},
          {1,A_C/3,A_C/6,0},
          {1,A_C/3,A_C/6,0},
          {0,    0,    0,0}}}
                
// el grupo FSSK_SimC, FSSK_SimL, FSSK_rotD, FSSK_rotI
// define operaciones en los indices de matriz
// FSSK_SimC {(0,1),(1,0),(2,3),(3,2)}    
// FSSK_SimL {(0,3),(1,2),(2,1),(3,0)}
// FSSK_rotD {(0,1),(1,2),(2,3),(3,0)}
// FSSK_rotI {(0,3),(1,0),(2,1),(3,2)}
#if ( FSSK_POV3_1 )
  #macro FSSK_SimC( I )
    #switch ( I )
    #case (0)
      1 
    #break
    #case (1)
      0
    #break
    #case (2)
      3
    #break
    #case (3)
      2
    #break 
    #end
  #end
#else
#declare FSSK_SimC   = function ( I )  { 
  select( I-1, 1, 0, select( I-2, -1, 3, 2 ) )
}
#end
   
#if ( FSSK_POV3_1 )
  #macro FSSK_SimL( I )
    #switch ( I )
    #case (0)
      3 
    #break
    #case (1)
      2
    #break
    #case (2)
      1
    #break
    #case (3)
      0
    #break 
    #end
  #end
#else
#declare FSSK_SimL   = function ( I )  {  
  select( I-1, 3, 2, select( I-2, -1, 1, 0 ) )
}
#end
    
#if ( FSSK_POV3_1 )
  #macro FSSK_rotD( I )
    #switch ( I )
    #case (0)
      1 
    #break
    #case (1)
      2
    #break
    #case (2)
      3
    #break
    #case (3)
      0
    #break 
    #end
  #end
#else    
#declare FSSK_rotD   = function ( I )  {
  select( I-1, 1, 2, select( I-2, -1, 3, 0 ) )
}
#end
  
#if ( FSSK_POV3_1 )
  #macro FSSK_rotI( I )
    #switch ( I )
    #case (0)
      3 
    #break
    #case (1)
      0
    #break
    #case (2)
      1
    #break
    #case (3)
      2
    #break 
    #end
  #end
#else
#declare FSSK_rotI   = function ( I )  {
  select( I-1, 3, 0, select( I-2, -1, 1, 2 ) )
}
#end


// Inicia el Bezier como un arreglo cuadrangular de vertices
// Ver1 = Superior Izquierda Ver2 Superior Derecha
// Ver3 = Inferior Izquierda Ver4 Inferior Derecha
// el esquema indicado es para la matriz Bezier
#macro FSSK_IniciarCasillaBezier ( NumeroCasilla, Ver1, Ver2, Ver3, Ver4 )  
  #if ( FSSK_BanderaReglaGiro )
    #local IVer3      = Ver4;
    #local IVer4      = Ver3;
  #else
    #local IVer3      = Ver3;
    #local IVer4      = Ver4;
  #end
  #declare FSSK_ArBezier[ NumeroCasilla ][0][0]  = Ver1;
  #declare FSSK_ArBezier[ NumeroCasilla ][0][1]  = (2*Ver1+Ver2)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][0][2] = (Ver1+2*Ver2)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][0][3] = Ver2;
  #declare FSSK_ArBezier[ NumeroCasilla ][1][0] = (2*Ver1+IVer3)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][1][1] = 
                                        (4*Ver1+2*Ver2+2*IVer3+IVer4)/9;
  #declare FSSK_ArBezier[ NumeroCasilla ][1][2] = 
                                        (4*Ver2+2*IVer4+2*Ver1+IVer3)/9;
  #declare FSSK_ArBezier[ NumeroCasilla ][1][3] = (2*Ver2+IVer4)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][2][0] = (Ver1+2*IVer3)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][2][1] = 
                                        (4*IVer3+2*IVer4+2*Ver1+Ver2)/9;
  #declare FSSK_ArBezier[ NumeroCasilla ][2][2] = 
                                        (4*IVer4+2*Ver2+2*IVer3+Ver1)/9;
  #declare FSSK_ArBezier[ NumeroCasilla ][2][3] = (Ver2+2*IVer4)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][3][0] = IVer3;
  #declare FSSK_ArBezier[ NumeroCasilla ][3][1] = (2*IVer3+IVer4)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][3][2] = (IVer3+2*IVer4)/3;
  #declare FSSK_ArBezier[ NumeroCasilla ][3][3] = IVer4;
#end   

          
#macro FSSK_AjusteBezierLateral ( NumeroCasilla, NumeroLado, Ajuste )
// El ajuste funciona con el siguiente grafico 
// en FSSK_ArBezier[NumeroCasilla] que es una Matriz de Puntos
// Ajuste es un vector, y en el ejemplo NumeroLado es 0
// MatrizPuntos + Ajuste*((0,    1,    1,0)
//                        (0,A_C/3,A_C/3,0)
//                        (0,A_C/6,A_C/6,0)
//                        (0,    0,    0,0))
// NumeroLado es 0,1,2 o 3 el ajustes es arriba, derecha, abajo o izquierda
// de la matriz
  #local    B       = 0;
  #while (B<4)
    #local C        = 0;
    #while (C<4)
      #declare FSSK_ArBezier[NumeroCasilla][B][C]       =
                FSSK_ArBezier[NumeroCasilla][B][C]
                +Ajuste*FSSK_ArregloFSSK_AjusteBezierLateral[NumeroLado][B][C];
      #local C      = C+1;
    #end
    #local B        = B+1;
  #end 
#end 

// macro simple para asignar texturas al arreglo Bezier
#macro FSSK_AsignarTexturaBezier ( NumeroCasilla, TexturaNueva )
  #declare FSSK_ArBezierTextura[ NumeroCasilla ]        = TexturaNueva;
#end

#macro FSSK_AjusteBezierCentral ( NumeroCasilla, Ajuste, FactorAtraccion ) 
// Ajuste el Bezier segun Numero Casilla
// sumando ajuste a los puntos de control centrales
  #local    B       = 1;
  #while (B<3)
    #local C        = 1;
    #while (C<3)
      #declare FSSK_ArBezier[NumeroCasilla][B][C]       =
         ( 1-FactorAtraccion )
         *FSSK_ArBezier[NumeroCasilla][FSSK_SimC(B)][FSSK_SimC(C)]
         +FactorAtraccion*FSSK_ArBezier[NumeroCasilla][B][C]+Ajuste;
      #local C      = C+1;
    #end
    #local B        = B+1;
  #end 
#end

// la macro se utiliza en estado plano para el Bezier
// despues probablemente, no de buen resultado
// el vertice en la matriz seria
// 0  Superior Izquierda        1  SuperiorDerecha
// 2  Inferior Derecho          3  InferiorIzquierda
// Intensidad 1 es bastante curva hacia 0(prohibido) disminuye
// la "fuerza" de la curva convirtiendose en cuadrado redondeado  
// BanderaSimetrico si false crea una especie de elipse que
// se puede redondear a rectangulo plano disminuyendo la intensidad
// si true se activa AjusteSimetrico que es float
// que se puede modificar para cambiar la intensidad en
// ambos sentidos (recomendado 1.0), y lograr el efecto deseado  
// si false BanderaSimetrico se ignora AjusteSimetrico
#macro FSSK_AjusteCurvoBezier ( NumeroCasilla, NumeroVertice, 
                Intensidad, BanderaSimetrico, AjusteSimetrico )
  #switch ( NumeroVertice )
    #case ( 0 )
      #local BR         = 0;
      #local BC         = 0;
      #local VR         = 1;
      #local VC         = 1;
    #break
    #case ( 1 )
      #local BR         = 0;                   
      #local BC         = 3;
      #local VR         = 1;
      #local VC         = 2;
    #break
    #case ( 2 )
      #local BR         = 3;
      #local BC         = 0;
      #local VR         = 2;
      #local VC         = 1;
    #break
    #case ( 3 )
      #local BR         = 3;
      #local BC         = 3;
      #local VR         = 2;
      #local VC         = 2;
    #break
  #end
  #local Distance1      = vlength( FSSK_ArBezier[ NumeroCasilla ][BR][BC]
                -FSSK_ArBezier[ NumeroCasilla ][BR][VC] ); 
  #local Distance2      = vlength( FSSK_ArBezier[ NumeroCasilla ][BR][BC]
                -FSSK_ArBezier[ NumeroCasilla ][VR][BC] );
  #if ( BanderaSimetrico ) 
    #local IntensidadCorregida    = 
       ( (Distance2<Distance1) ? 
           (Intensidad*Distance2/Distance1) : Intensidad );
  #else
    #local Intensidad2    = Distance2/Distance1;
    #local Intensidad1    = Distance1/Distance2;   
  #end
  #if ( BanderaSimetrico )
    #declare FSSK_ArBezier[ NumeroCasilla ][BR][VC]       =
        (1-IntensidadCorregida)*FSSK_ArBezier[ NumeroCasilla ][BR][BC]
        +IntensidadCorregida*( 2*FSSK_ArBezier[ NumeroCasilla ][BR][VC]
                -FSSK_ArBezier[ NumeroCasilla ][VR][VC] );
    #declare FSSK_ArBezier[ NumeroCasilla ][VR][BC]       =
        (1+AjusteSimetrico)*FSSK_ArBezier[ NumeroCasilla ][BR][BC]
                -AjusteSimetrico*FSSK_ArBezier[ NumeroCasilla ][BR][VC];  
  #else 
    #declare FSSK_ArBezier[ NumeroCasilla ][BR][VC]       =
        (1-Intensidad)*FSSK_ArBezier[ NumeroCasilla ][BR][BC]
        +Intensidad*( ( 1+Intensidad1 )
                *FSSK_ArBezier[ NumeroCasilla ][BR][VC]
                -Intensidad1*FSSK_ArBezier[ NumeroCasilla ][VR][VC] );
    #declare FSSK_ArBezier[ NumeroCasilla ][VR][BC]       =
        (1-Intensidad)*FSSK_ArBezier[ NumeroCasilla ][BR][BC]
        +Intensidad*( ( 1+Intensidad2 )
                *FSSK_ArBezier[ NumeroCasilla ][VR][BC]
                -Intensidad2*FSSK_ArBezier[ NumeroCasilla ][VR][VC] );
  #end
#end   
  
// Esta macro
// "fuerza la igualdad" entre dos bordes
// el borde de NumeroCasilla se hace igual que el de CasillaReferencia 
// el Lado se identifica por
// 0  lado superior de matriz
// 1  lado derecho de matriz
// 2  lado inferior de matriz
// 3  lado izquierdo de matriz
// si BanderaInvertir es true
// se asignan los puntos asumiendo que
// ambos tienen la misma orientacion horaria o antihoraria
// esto produce "cierta" inversion en las juntas
// la bandera "false" cuando esto no se cumpla
#macro FSSK_AjusteBordesBezier ( NumeroCasilla, LadoCasilla, 
                CasillaReferencia, LadoReferencia, BanderaInvertir )
  #local B              = 0;
  #while ( B < 4 )
    #local R            = ( BanderaInvertir ? 3-B : B );
    #switch ( LadoCasilla)
      #case ( 0 )
        #local FilaCasilla      = 0;
        #local ColumnaCasilla   = B;
      #break
      #case ( 1 )
        #local FilaCasilla      = B;
        #local ColumnaCasilla   = 3;
      #break
      #case ( 2 )
        #local FilaCasilla      = 3;
        #local ColumnaCasilla   = 3-B;
      #break
      #case ( 3 )
        #local FilaCasilla      = 3-B;
        #local ColumnaCasilla   = 0;
      #break
    #end
    #switch ( LadoReferencia )
      #case ( 0 )
        #local FilaReferencia       = 0;
        #local ColumnaReferencia    = R;
      #break
      #case ( 1 )
        #local FilaReferencia       = R;
        #local ColumnaReferencia    = 3;
      #break
      #case ( 2 )
        #local FilaReferencia       = 3;
        #local ColumnaReferencia    = 3-R;
      #break
      #case ( 3 )
        #local FilaReferencia       = 3-R;
        #local ColumnaReferencia    = 0;
      #break
    #end
    #declare FSSK_ArBezier[NumeroCasilla][FilaCasilla][ColumnaCasilla] =
  FSSK_ArBezier[CasillaReferencia][FilaReferencia][ColumnaReferencia];
    #local B            = B+1;
  #end       
#end  
    
// esta macro debe utilizarse despues de haber incrementado
// el valor de FSSK_DefinidoB
// cuando sea pertinente
// subdivide un Bezier en cinco, el del centro es plano
// HerenciaTextura = true;  hereda la textura del padre en los hijos    
#macro FSSK_SubdivisionMarcoPlanoBezier ( NumeroCasilla, HerenciaTextura )
  FSSK_IniciarCasillaBezier( FSSK_DefinidoB,
        FSSK_ArBezier[ NumeroCasilla ][0][0],
        FSSK_ArBezier[ NumeroCasilla ][0][3],
        FSSK_ArBezier[ NumeroCasilla ][1][2],
        FSSK_ArBezier[ NumeroCasilla ][1][1] )
  FSSK_AjusteBordesBezier(FSSK_DefinidoB,0,NumeroCasilla,0,false)
  #declare FSSK_DefinidoB       = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier( FSSK_DefinidoB,
        FSSK_ArBezier[ NumeroCasilla ][1][2],
        FSSK_ArBezier[ NumeroCasilla ][0][3],
        FSSK_ArBezier[ NumeroCasilla ][3][3],
        FSSK_ArBezier[ NumeroCasilla ][2][2] )
  FSSK_AjusteBordesBezier(FSSK_DefinidoB,1,NumeroCasilla,1,false)
  #declare FSSK_DefinidoB       = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier( FSSK_DefinidoB,
        FSSK_ArBezier[ NumeroCasilla ][2][1],
        FSSK_ArBezier[ NumeroCasilla ][2][2],
        FSSK_ArBezier[ NumeroCasilla ][3][3],
        FSSK_ArBezier[ NumeroCasilla ][3][0] )
  FSSK_AjusteBordesBezier(FSSK_DefinidoB,2,NumeroCasilla,2,false)
  #declare FSSK_DefinidoB       = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier( FSSK_DefinidoB,
        FSSK_ArBezier[ NumeroCasilla ][0][0],
        FSSK_ArBezier[ NumeroCasilla ][1][1],
        FSSK_ArBezier[ NumeroCasilla ][2][1],
        FSSK_ArBezier[ NumeroCasilla ][3][0] )
  FSSK_AjusteBordesBezier(FSSK_DefinidoB,3,NumeroCasilla,3,false)
  #declare FSSK_DefinidoB       = FSSK_DefinidoB+1;
  #local V1             = FSSK_ArBezier[ NumeroCasilla ][1][1];
  #local V2             = FSSK_ArBezier[ NumeroCasilla ][1][2];
  #local V3             = FSSK_ArBezier[ NumeroCasilla ][2][2];
  #local V4             = FSSK_ArBezier[ NumeroCasilla ][2][1];
  FSSK_IniciarCasillaBezier(NumeroCasilla,V1,V2,V3,V4)
  #if ( HerenciaTextura )
    #local A    = FSSK_DefinidoB-4;
    #while ( A < FSSK_DefinidoB )
      #declare FSSK_ArBezierTextura[ A ]        = 
                        FSSK_ArBezierTextura[ NumeroCasilla ];
      #local A  = A+1;
    #end
  #end
#end   
                                
// FSSK = Porshe Bezier de Transporte Diario                                
#macro   FSSK_SplineLinealBezier( NuevoV, Pu, v0, v1, v2, v3 )
  #declare NuevoV       = pow( ( 1-Pu ), 3 )*v0+
                3*Pu*( 1-Pu )*( 1-Pu )*v1        
                +3*Pu*Pu*( 1-Pu )*v2+pow( Pu, 3 )*v3;
#end

#macro   FSSK_DerivadaSplineLinealBezier ( NuevoV, Pu, v0, V1, v2, v3 )          
  #declare NuevoV       = -3*( 1-Pu )*( 1-Pu )*v0+3*( 1-3*Pu )*( 1-Pu )*v1
                +3*( 2-3*Pu )*Pu*v2+3*Pu*Pu*v3;
#end

#macro   FSSK_UbicarNormalGuiaUnitaria 
                ( NuevoV, Base, Referencia, NormalUnitaria, Intensidad )
  #declare NuevoV       = Base+Intensidad*( ( Referencia-Base )
        -vdot( Referencia-Base, NormalUnitaria )*NormalUnitaria );
#end 

#macro   FSSK_LaminaBezier ( NumeroCasilla, Empuje, OpcionSteps )
  FSSK_GemeloBezier( FSSK_DefinidoB, NumeroCasilla, true )
  #local   Ajustado            = FSSK_DefinidoB;
  #declare FSSK_DefinidoB      = FSSK_DefinidoB+1;
  #if ( FSSK_POV3_1 )
    #macro MyAjuste ( MyVector )
      MyAjuste+Empuje
    #end
  #else
  #local   MyAjuste            = function      {
       transform {
          translate Empuje
       }
  }
  #end
  FSSK_TransformBezier( Ajustado, MyAjuste ) 
  #local   Lateral1            = FSSK_DefinidoB;
  #declare FSSK_DefinidoB      = FSSK_DefinidoB+4;
  FSSK_IniciarCasillaBezier( Lateral1      ,
        FSSK_ArBezier[ NumeroCasilla ][0][0],
        FSSK_ArBezier[ NumeroCasilla ][0][3],
        FSSK_ArBezier[ Ajustado      ][0][3],
        FSSK_ArBezier[ Ajustado      ][0][0] ) 
  FSSK_IniciarCasillaBezier( Lateral1+1    ,
        FSSK_ArBezier[ Ajustado      ][0][3],
        FSSK_ArBezier[ NumeroCasilla ][0][3],
        FSSK_ArBezier[ NumeroCasilla ][3][3],
        FSSK_ArBezier[ Ajustado      ][3][3] ) 
  FSSK_IniciarCasillaBezier( Lateral1+2    ,
        FSSK_ArBezier[ Ajustado      ][3][0],
        FSSK_ArBezier[ Ajustado      ][3][3],
        FSSK_ArBezier[ NumeroCasilla ][3][3],
        FSSK_ArBezier[ NumeroCasilla ][3][0] ) 
  FSSK_IniciarCasillaBezier( Lateral1+3    ,
        FSSK_ArBezier[ NumeroCasilla ][0][0],
        FSSK_ArBezier[ Ajustado      ][0][0],         
        FSSK_ArBezier[ Ajustado      ][3][0],
        FSSK_ArBezier[ NumeroCasilla ][3][0] ) 
  #local C                      = 0;
  #while ( C < 4 )
    FSSK_AjusteBordesBezier(Lateral1+C,C,NumeroCasilla,C,false )
    FSSK_AjusteBordesBezier(Lateral1+C,FSSK_rotD(FSSK_rotD(C)),Ajustado     ,C,true   ) 
    #declare FSSK_ArBezierTextura[ Lateral1+C ] =
                        FSSK_ArBezierTextura[ NumeroCasilla ];
    #local D                    = ( ( C = 1 ) | ( C = 3 ) );
    FSSK_AplanarCentroBezier( Lateral1+C, D )
    #local C                    = C+1; 
    #if ( OpcionSteps >= 0 )
      // corrige el u_steps(blue) o bien v_steps(filter)
      #if ( D )
        #declare FSSK_ArBezierTipo[ Lateral1+C ]  =
         FSSK_ArBezierTipo[ Lateral1+C ]*<1,1,0,1,1>+<0,0,OpcionSteps,0,0>;
      #else
        #declare FSSK_ArBezierTipo[ Lateral1+C ]  =
         FSSK_ArBezierTipo[ Lateral1+C ]*<1,1,1,0,1>+<0,0,0,OpcionSteps,0>;
      #end
    #end
  #end
#end
                     
#macro   FSSK_CorreccionBezierNormal
  ( NumeroCasilla, Vertice, Normal, Intensidad1, Intensidad2, Intensidad3 )
  #local   NormalUnitaria       = vnormalize( Normal );
  #switch ( Vertice )
    #case ( 0 )
      #local    B               = 0;
      #local    C               = 0;
    #break
    #case ( 1 )
      #local    B               = 0;
      #local    C               = 3;
    #break
    #case ( 2 )
      #local    B               = 3;
      #local    C               = 3;
    #break
    #case ( 3 )
      #local    B               = 3;
      #local    C               = 0;
    #break
  #end
  FSSK_UbicarNormalGuiaUnitaria( 
        FSSK_ArBezier[ NumeroCasilla ][FSSK_SimC(B)][C],
        FSSK_ArBezier[ NumeroCasilla ][B][C],
        FSSK_ArBezier[ NumeroCasilla ][FSSK_SimL(B)][C], 
        NormalUnitaria, Intensidad1 );
  FSSK_UbicarNormalGuiaUnitaria( 
        FSSK_ArBezier[ NumeroCasilla ][FSSK_SimC(B)][FSSK_SimC(C)],
        FSSK_ArBezier[ NumeroCasilla ][B][C],
        FSSK_ArBezier[ NumeroCasilla ][FSSK_SimL(B)][FSSK_SimL(C)], 
        NormalUnitaria, Intensidad2 );
  FSSK_UbicarNormalGuiaUnitaria( 
        FSSK_ArBezier[ NumeroCasilla ][B][FSSK_SimC(C)],
        FSSK_ArBezier[ NumeroCasilla ][B][C],
        FSSK_ArBezier[ NumeroCasilla ][B][FSSK_SimL(C)], 
        NormalUnitaria, Intensidad3 );
#end  

#macro   FSSK_AplanarCentroBezier ( NumeroCasilla, BanderaHorizontal )
  #local B              = 1;
  #while ( B < 3 )
    #local C            = 1;
    #while ( C < 3 )
      #if ( BanderaHorizontal )
        #declare FSSK_ArBezier[ NumeroCasilla ][B][C]   =
                ( 2*FSSK_ArBezier[ NumeroCasilla ][B][FSSK_SimC(C)] 
                   +FSSK_ArBezier[ NumeroCasilla ][B][FSSK_SimL(FSSK_SimC(C))] )/3;
      #else
        #declare FSSK_ArBezier[ NumeroCasilla ][B][C]   =
                ( 2*FSSK_ArBezier[ NumeroCasilla ][FSSK_SimC(B)][C] 
                   +FSSK_ArBezier[ NumeroCasilla ][FSSK_SimL(FSSK_SimC(B))][C] )/3;
      #end
      #local C          = C+1;
    #end
    #local B            = B+1;
  #end
#end  

#macro FSSK_TransformBezier ( NumeroCasilla, MyTransform ) 
  #local FSSK_PivoteBezier              = array [4][4];
  #local B              = 0;
  #while ( B < 4 )
    #local C            = 0;
    #while ( C < 4 )      
      #declare FSSK_PivoteBezier[B][C]  =
                   MyTransform( FSSK_ArBezier[ NumeroCasilla ][B][C].x,
                                FSSK_ArBezier[ NumeroCasilla ][B][C].y,
                                FSSK_ArBezier[ NumeroCasilla ][B][C].z );
      #local C          = C+1;
    #end
    #local B            = B+1;
  #end
  #local B              = 0;
  #while ( B < 4 )
    #local C            = 0;
    #while ( C < 4 )
      #declare FSSK_ArBezier[ NumeroCasilla ][B][C]     =
                 FSSK_PivoteBezier[B][C];
      #local C          = C+1;
    #end
    #local B            = B+1;
  #end
#end

#macro FSSK_GemeloBezier
        ( NumeroCasilla, CasillaReferencia, HerenciaTextura )
  #local B              = 0;
  #while ( B < 4 )
    #local C            = 0;
    #while ( C < 4 )
      #declare FSSK_ArBezier[ NumeroCasilla ][B][C]      =
                 FSSK_ArBezier[ CasillaReferencia ][B][C];
      #if ( HerenciaTextura )
        #declare FSSK_ArBezierTextura[ NumeroCasilla ]  =
                        FSSK_ArBezierTextura[ CasillaReferencia ];
      #end
      #local C          = C+1;
    #end
    #local B            = B+1;
  #end
#end           

#macro FSSK_CompresionBezierHilera 
        ( NumeroCasilla, Factor, Sentido, Hilera )
  #local Vector                         = array [4];
  #local Diferencia                     = array [4];
  #local SegundaDiferencia              = array [4];
  #switch ( Sentido )
    #case ( 0 )
      #local OF         = 0;
      #local OC         = Hilera;
      #local VF         = 1;
      #local VC         = 0;
    #break
    #case ( 1 )
      #local OF         = Hilera;
      #local OC         = 3;
      #local VF         = 0;
      #local VC         = -1;
    #break
    #case ( 2 )
      #local OF         = 3;
      #local OC         = 3-Hilera;
      #local VF         = -1;
      #local VC         = 0;
    #break
    #case ( 3 )
      #local OF         = 3-Hilera;
      #local OC         = 0;
      #local VF         = 0;
      #local VC         = 1;
    #break
  #end
  #local C              = 0;
  #while ( C < 4 )
    #local Vector[ C ]  = FSSK_ArBezier[ NumeroCasilla ][OF+C*VF][OC+C*VC];
    #if ( C >= 1 )
      #local Diferencia[ C-1 ]          = Vector[ C ]-Vector[ C-1 ];
    #end
    #if ( C >= 2 )
      #local SegundaDiferencia[ C-2 ]   = 
                        Diferencia[ C-1 ]-Diferencia[ C-2 ];
    #end
    #local C            = C+1;
  #end
  #declare FSSK_ArBezier[ NumeroCasilla ][OF+VF][OC+VC]         =
        Factor*Diferencia[ 0 ]+Vector[ 0 ];      
  #declare FSSK_ArBezier[ NumeroCasilla ][OF+2*VF][OC+2*VC]     =
        Factor*Factor*SegundaDiferencia[ 0 ]
        +2*Factor*Diferencia[ 0 ]+Vector[ 0 ];      
  #declare FSSK_ArBezier[ NumeroCasilla ][OF+3*VF][OC+3*VC]     =
        pow( Factor, 3 )*( SegundaDiferencia[ 1 ]-SegundaDiferencia[ 0 ] )
        +3*Factor*Factor*SegundaDiferencia[ 0 ]
        +3*Factor*Diferencia[ 0 ]+Vector[ 0 ];      
#end

#macro FSSK_CompresionBezier ( NumeroCasilla, Factor, Sentido )
  #local B      = 0;
  #while ( B < 4 )
    FSSK_CompresionBezierHilera( NumeroCasilla, Factor, Sentido, B )
    #local B    = B+1;
  #end
#end

#macro VerticeBezier ( NuevoV, NumeroCasilla, Vertice )
  #switch ( Vertice )
    #case ( 0 )
      #declare NuevoV   = FSSK_ArBezier[ NumeroCasilla ][0][0];
    #break
    #case ( 1 )
      #declare NuevoV   = FSSK_ArBezier[ NumeroCasilla ][0][3];
    #break
    #case ( 2 )
      #declare NuevoV   = FSSK_ArBezier[ NumeroCasilla ][3][3];
    #break
    #case ( 3 )
      #declare NuevoV   = FSSK_ArBezier[ NumeroCasilla ][3][0];
    #break
  #end
#end 

#macro FSSK_PSeudoNormalBezier ( NumeroCasilla, NuevoV )
   #declare NuevoV      = vnormalize( vcross( 
        FSSK_ArBezier[ NumeroCasilla ][2][2]
                -FSSK_ArBezier[ NumeroCasilla ][0][0], 
        FSSK_ArBezier[ NumeroCasilla ][3][3]
                -FSSK_ArBezier[ NumeroCasilla ][1][1] ) );
#end

#macro FSSK_BordeBezier ( NuevoV, NumeroCasilla, Pu, NumeroLado )
  #switch ( NumeroLado )
    #case ( 0 ) 
      #local FO         = 0;
      #local CO         = 0;
      #local FV         = 0;
      #local CV         = 1;
    #break
    #case ( 1 )
      #local FO         = 0;
      #local CO         = 3;
      #local FV         = 1;
      #local CV         = 0;
    #break
    #case ( 2 )
      #local FO         = 3;
      #local CO         = 3;
      #local FV         = 0;
      #local CV         = -1;
    #case ( 3 )
      #local FO         = 3;
      #local CO         = 0;
      #local FV         = -1;
      #local CV         = 0;
    #break
  #end
  #local v0             = FSSK_ArBezier[ NumeroCasilla ][FO][CO];
  #local v1             = FSSK_ArBezier[ NumeroCasilla ][FO+FV][CO+CV];
  #local v2             = FSSK_ArBezier[ NumeroCasilla ][FO+2*FV][CO+2*CV];
  #local v3             = FSSK_ArBezier[ NumeroCasilla ][FO+3*FV][CO+3*CV];
  FSSK_SplineLinealBezier( NuevoV, Pu, v0, v1, v2, v3 )
#end

#macro FSSK_ArregloLaminadoIF ( Inicio, Fin )     
  #local BanderaPivote  = DEBUG;
Set_Debug( FSSK_BanderaDebug )
  union {
    #local A      = Inicio;
Debug_Message( "Estoy es la lista de FSSK_ArBezier activa\n" )
    #while (A<= Fin)
      #if ( FSSK_ArBezierTipo[A].red = on )
Debug_Message( concat( "Se genera el FSSK_ArBezier : ", 
                str(A,3,0),"\n" ) )
        bicubic_patch       {        
          type      FSSK_ArBezierTipo[A].green
          flatness  FSSK_ArBezierTipo[A].transmit
          u_steps   FSSK_ArBezierTipo[A].blue  
          v_steps   FSSK_ArBezierTipo[A].filter
          #local    B       = 0;
          #while (B<4)
            #local C        = 0;
            #while (C<4)
              FSSK_ArBezier[A][B][C]
Debug_Message( concat( " ", "[",str(B,1,0),"]","[",str(C,1,0),"] = ",
                FSSK_VStr( FSSK_ArBezier[A][B][C]*1000 ),"*L" ) )
Debug( ( ( C = 1 ) & FSSK_BanderaDebug ),"\n  ")                
              #local C      = C+1;
            #end
Debug_Message( "\n" ) 
            #local B        = B+1;
          #end
          texture   { 
            FSSK_ArBezierTextura[ A ]
          }
        }
      #end
      #local A    = A+1;
    #end
Debug_Message( "Ultimo FSSK_ArBezier\n" )
  }
  #local DEBUG          = BanderaPivote;
#end

#macro FSSK_ArregloLaminado ()
  FSSK_ArregloLaminadoIF(0,FSSK_DefinidoB-1)
#end
