// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 7 Noviembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El soporte de todos los cubiertos descansa en el plano xz
// El origen de la mayoria se encuentra en el mango
// (la parte delantera centrada del mango, inferior )
// En el caso del cuchillo el origen se desplaza
// adelante hacia la hoja, como 1/4 de longitud de hoja
// Cuchillo...
// Minimo <  -111,     0,  -12>*L
// Maximo <    67,     2,    7>*L
// Cucharita...
// Minimo <   -87,   -11,  -19>*L
// Maximo <    44,     5,   19>*L
// Cuchara...
// Minimo <  -120,   -14,  -24>*L
// Maximo <    55,     6,   24>*L
// Tenedor...
// Minimo <  -120,    -5,  -13>*L
// Maximo <    56,     6,   13>*L
//
// Algunos modificadores
// #declare FSSK_TexturaMetal           = texture { ... }
//      se refiere a la textura metalica en general  
// #declare FSSK_TexturaTroncoDorado    = texture { ... }
//      se refiere al decorado dorado
//      nicamente se aplica en la parte superior del tronco 
// #declare FSSK_TexturaCortante        = texture { ... }
//      se aplica a la zona filosa del cuchillo
// en caso de redefinirse, debera hacerlo antes del include.
//
// Para colocarlo simplemente 
// include "ForkSSK.inc";
// object { FSSK_Cucharita }, ...
// object { FSSK_Cuchara   }, ...
// object { FSSK_Cuchillo  }, ...
// object { FSSK_Tenedor   }
// nota:  el archivo "FSSK_Bez.inc", es auxiliar
//     y no se llama directamente... 
//    FSSK : ForkSpoonSpoonKnife
// 

#include "colors.inc"              
#include "metals.inc"

#declare FSSK_POV3_1          = off;


#declare L                      = 0.001; 
      
#ifndef ( FSSK_TexturaMetal )
  #declare FSSK_TexturaMetal           = texture { 
    T_Silver_4A  
    normal {
      average 
      normal_map    {
        [0.3 spotted turbulence 0.5 frequency 4.0 ]
        [0.7 bumps bump_size 2 
                  frequency 4.0 turbulence 0.5 lambda 5.0 omega 0.5 ]
      }
    }
  } 
#end 

#declare FSSK_BezierTexturaDefault              = texture {
  FSSK_TexturaMetal
}

#include "FSSK_Bez.inc"

#declare FSSK_LineaDorada                    = texture {
  T_Gold_1A
} 
         

#declare FSSK_FiloCuchillo                   = texture {
  uv_mapping
  brick
  texture       { 
    FSSK_TexturaMetal
    scale       20
    translate   5*z+2*x
  },
  texture       {
    #ifndef ( FSSK_TexturaCortante )
      T_Chrome_4A
      normal { bumps }
    #else
      FSSK_TexturaCortante
    #end
  } 
  mortar        2
  scale         0.35
  translate     0.2*x+0.7*y
}


#ifndef ( FSSK_TexturaTroncoDorado )
  #declare FSSK_TexturaTroncoDorado   = texture {
    uv_mapping  
    boxed 
      scale       0.5
      translate   <0.5,0.5,0> 
      texture_map {
        [ 0.025 FSSK_BezierTexturaDefault ]
        [ 0.025  FSSK_LineaDorada             ]
        [ 0.04 FSSK_LineaDorada ]
        [ 0.04 FSSK_BezierTexturaDefault    ]
        [ 0.98 FSSK_LineaDorada ]
      }
  
  }
#end

// transforms auxiliares   
#if ( FSSK_POV3_1 )
  #macro FSSK_SimetricoY ( MyVector )
    MyVector*<1,-1,1>
  #end
#else
#declare FSSK_SimetricoY        = function      {
  transform     {
    scale       < 1,-1, 1 >
  }
} 
#end             

#macro   FSSK_Anti ( NumeroCasilla )
  FSSK_GemeloBezier( FSSK_DefinidoB, NumeroCasilla, true )
  FSSK_TransformBezier( FSSK_DefinidoB, FSSK_SimetricoY )
  #declare FSSK_DefinidoB         = FSSK_DefinidoB+1;   
#end  


#macro FSSK_HacerCuchara ()
  #declare FSSK_InicioCuchara                = FSSK_DefinidoB;
  #local   LargoCuchara                 = 75*L;
  #local   ProfundidadAgarreCuchara     = 11.25*L;
  #local   ProfundidadCuchara           = 6.25*L;
  #local   GruesoCuchara                = 1.25*L;
  #local   GruesoFinoCuchara            = 0.3125*L;
  #local   LargoPrincipalCuchara        = 53.75*L;
  #local   HondoCuchara                 = 12.5*L;
  #local   IdePrincipalCuchara          = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdePrincipalCuchara,
            <0,0,+ProfundidadCuchara/2>,
            <+1.90*LargoPrincipalCuchara/2,0,+1.90*ProfundidadCuchara/2>,
            <+1.90*LargoPrincipalCuchara/2,0,-1.90*ProfundidadCuchara/2>,
            <0,0,-ProfundidadCuchara/2> ) 
            // +1 se refiere al gemelo superior en AjustarBordes... 
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCuchara, 0, 0.9, false, 1.0 )
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCuchara, 2, 0.9, false, 1.0 )
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCuchara, 1, 0.9, false, 1.0 )
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCuchara, 3, 0.9, false, 1.0 )
  FSSK_AjusteBezierCentral( IdePrincipalCuchara, <0,-HondoCuchara,0>, 1.0 )
  FSSK_AjusteBezierLateral( IdePrincipalCuchara,0,<0,-2.5*L,0>)
  FSSK_AjusteBezierLateral( IdePrincipalCuchara,2,<0,-2.5*L,0>)
  #local   IdeSupPrincipalCuchara       = FSSK_DefinidoB;
  #declare FSSK_DefinidoB       = FSSK_DefinidoB+1;
  FSSK_GemeloBezier( IdeSupPrincipalCuchara, IdePrincipalCuchara, true )
  #local   IdeTroncoCuchara             = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdeTroncoCuchara,
            <-LargoCuchara,0,+ProfundidadAgarreCuchara/2>,
            <0,0,+ProfundidadCuchara/2>,
            <0,0,-ProfundidadCuchara/2>,
            <-LargoCuchara,0,-ProfundidadAgarreCuchara/2> )  
  #local   C                            = 0;
  #while ( C < 4 )
    FSSK_CorreccionBezierNormal
        ( IdeTroncoCuchara, C, <0.01,0.1,0>, 0.4,0.4,0.4 )
    #local C                            = C+1;
  #end
  FSSK_AjusteCurvoBezier( IdeTroncoCuchara, 0, 10.0, true, 1.0) 
  FSSK_AjusteCurvoBezier( IdeTroncoCuchara, 2, 10.0, true, 1.0)
  FSSK_LaminaBezier( IdeTroncoCuchara, <0,GruesoCuchara,0>, 0 )  
  FSSK_AsignarTexturaBezier( IdeTroncoCuchara+1, FSSK_TexturaTroncoDorado )
  FSSK_AjusteBordesBezier
        ( IdePrincipalCuchara   , 3, IdeTroncoCuchara  , 1, true )
  FSSK_AjusteBordesBezier
        ( IdeSupPrincipalCuchara, 3, IdeTroncoCuchara+1, 1, true )
  #declare FSSK_FinCuchara           = FSSK_DefinidoB-1;
#end
    
#macro FSSK_HacerBaseTenedor ()
  #declare FSSK_InicioTenedor                = FSSK_DefinidoB;
  #local   LargoTenedor                 = 75*L;
  #local   ProfundidadAgarreTenedor     = 11.25*L;
  #local   ProfundidadMangoTenedor      = 6.25*L;
  #local   ProfundidadTenedor           = 25*L;
  #local   GruesoTenedor                = 1.25*L;
  #local   GruesoFinoTenedor            = 0.8125*L;
  #local   LargoPrincipalTenedor        = 53.75*L; 
  #local   LargoBaseTenedor             = 0.9*LargoPrincipalTenedor/3;    
  #local   LargoDientes                 = 2.5*LargoBaseTenedor;
  #local   HondoTenedor                 = LargoBaseTenedor/3;
  #local   IdePrincipalTenedor          = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdePrincipalTenedor,
            <0,-HondoTenedor,+ProfundidadTenedor/2>,
            <+LargoBaseTenedor,-HondoTenedor,+ProfundidadTenedor/2>,
            <+LargoBaseTenedor,-HondoTenedor,-ProfundidadTenedor/2>,
            <0,-HondoTenedor,-ProfundidadTenedor/2> )
  FSSK_LaminaBezier( IdePrincipalTenedor, <0,GruesoFinoTenedor,0>, 0 )  
  #local   IdeHojaDientes               = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1; 
  FSSK_IniciarCasillaBezier
        (IdeHojaDientes,
            <+LargoBaseTenedor,-HondoTenedor,+ProfundidadTenedor/2>,
   <+LargoBaseTenedor+LargoDientes,+HondoTenedor,+ProfundidadTenedor/2>,
   <+LargoBaseTenedor+LargoDientes,+HondoTenedor,-ProfundidadTenedor/2>,
            <+LargoBaseTenedor,-HondoTenedor,-ProfundidadTenedor/2> )
  FSSK_CorreccionBezierNormal( IdeHojaDientes, 0, <0,1,0>, 0.2, 0.2, 0.2 ) 
  FSSK_CorreccionBezierNormal( IdeHojaDientes, 3, <0,1,0>, 0.2, 0.2, 0.2 ) 
  FSSK_LaminaBezier( IdeHojaDientes, <0,GruesoFinoTenedor,0>, 0 )  
  #local   IdeTroncoTenedor             = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdeTroncoTenedor,
            <-LargoTenedor,0,+ProfundidadAgarreTenedor/2>,
            <0,0,+ProfundidadMangoTenedor/2>,
            <0,0,-ProfundidadMangoTenedor/2>,
            <-LargoTenedor,0,-ProfundidadAgarreTenedor/2> )  
  #local   C                            = 0;
  #while ( C < 4 )
    FSSK_CorreccionBezierNormal
        ( IdeTroncoTenedor, C, <0.01,0.1,0>, 0.4,0.4,0.4 )
    #local C                            = C+1;
  #end
  FSSK_AjusteCurvoBezier( IdeTroncoTenedor, 0, 10.0, true, 1.0) 
  FSSK_AjusteCurvoBezier( IdeTroncoTenedor, 2, 10.0, true, 1.0)
  FSSK_LaminaBezier( IdeTroncoTenedor, <0,GruesoTenedor,0>, 0 )  
  FSSK_AsignarTexturaBezier( IdeTroncoTenedor+1, FSSK_TexturaTroncoDorado )
  FSSK_AjusteBordesBezier
        ( IdePrincipalTenedor   , 3, IdeTroncoTenedor  , 1, true )
  FSSK_AjusteBordesBezier
        ( IdePrincipalTenedor+1 , 3, IdeTroncoTenedor+1, 1, true )
  #declare FSSK_FinTenedor           = FSSK_DefinidoB-1;
#end

#macro FSSK_HacerCucharita ()
  #declare FSSK_InicioCucharita              = FSSK_DefinidoB;
  #local   LargoCucharita               = 1.1*75*L;
  #local   ProfundidadAgarreCucharita   = 11.25*L;
  #local   ProfundidadCucharita         = 0.8*6.25*L;
  #local   GruesoCucharita              = 1.25*L;
  #local   GruesoFinoCucharita          = 0.3125*L;
  #local   LargoPrincipalCucharita      = 0.8*53.75*L;
  #local   HondoCucharita               = 0.8*12.5*L;
  #local   IdePrincipalCucharita        = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdePrincipalCucharita,
            <0,0,+ProfundidadCucharita/2>,
          <+1.90*LargoPrincipalCucharita/2,0,+1.90*ProfundidadCucharita/2>,
          <+1.90*LargoPrincipalCucharita/2,0,-1.90*ProfundidadCucharita/2>,
            <0,0,-ProfundidadCucharita/2> ) 
            // +1 se refiere al gemelo superior en AjustarBordes... 
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCucharita, 0, 0.9, false, 1.0 )
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCucharita, 2, 0.9, false, 1.0 )
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCucharita, 1, 0.9, false, 1.0 )
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCucharita, 3, 0.9, false, 1.0 )
  FSSK_AjusteBezierCentral( IdePrincipalCucharita, <0,-HondoCucharita,0>, 1.0 )
  FSSK_AjusteBezierLateral( IdePrincipalCucharita,0,0.8*<0,-2.5*L,0>)
  FSSK_AjusteBezierLateral( IdePrincipalCucharita,2,0.8*<0,-2.5*L,0>)
  #local   IdeSupPrincipalCucharita       = FSSK_DefinidoB;
  #declare FSSK_DefinidoB       = FSSK_DefinidoB+1;
  FSSK_GemeloBezier
    ( IdeSupPrincipalCucharita, IdePrincipalCucharita, true )
  #local   IdeTroncoCucharita             = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdeTroncoCucharita,
            <-LargoCucharita,0,+ProfundidadAgarreCucharita/2>,
            <0,0,+ProfundidadCucharita/2>,
            <0,0,-ProfundidadCucharita/2>,
            <-LargoCucharita,0,-ProfundidadAgarreCucharita/2> )  
  #local   C                            = 0;
  #while ( C < 4 )
    FSSK_CorreccionBezierNormal
        ( IdeTroncoCucharita, C, <0.01,0.1,0>, 0.4,0.4,0.4 )
    #local C                            = C+1;
  #end
  FSSK_AjusteCurvoBezier( IdeTroncoCucharita, 0, 1.0, true, 1.0) 
  FSSK_AjusteCurvoBezier( IdeTroncoCucharita, 2, 1.0, true, 1.0)
  FSSK_LaminaBezier( IdeTroncoCucharita, <0,GruesoCucharita,0>, 0 )  
  FSSK_AsignarTexturaBezier( IdeTroncoCucharita+1, FSSK_TexturaTroncoDorado )
  FSSK_AjusteBordesBezier
        ( IdePrincipalCucharita   , 3, IdeTroncoCucharita  , 1, true )
  FSSK_AjusteBordesBezier
        ( IdeSupPrincipalCucharita, 3, IdeTroncoCucharita+1, 1, true )
  #declare FSSK_FinCucharita         = FSSK_DefinidoB-1;
#end


#macro FSSK_HacerBaseCuchillo ()
  #declare FSSK_InicioCuchillo               = FSSK_DefinidoB;
  #local   LargoCuchillo                = 75*L;
  #local   ProfundidadAgarreCuchillo    = 11.25*L;
  #local   ProfundidadCuchillo          =  8.75*L;
  #local   GruesoCuchillo               = 2.0*L;
  #local   GruesoFinoCuchillo           = 0.3125*L;
  #local   LargoPrincipalCuchillo       = 1.73*53.75*L;
  #local   HondoCuchillo                = 12.5*L;
  #local   IdePrincipalCuchillo         = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdePrincipalCuchillo,
            <0,0,+ProfundidadCuchillo/2>,
            <+1.90*LargoPrincipalCuchillo/2,0,+ProfundidadCuchillo/2>,
            <+1.90*LargoPrincipalCuchillo/2,0,-ProfundidadCuchillo/2>,
            <0,0,-ProfundidadCuchillo/2> )     
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCuchillo, 3, 1.0, true, 3.0 )
  FSSK_AjusteCurvoBezier
        ( IdePrincipalCuchillo, 1, 1.0, true, 3.0 )
  FSSK_AjusteBezierLateral( IdePrincipalCuchillo,2,<2.5*L,0,-7.5*L>)
  FSSK_AjusteBezierLateral( IdePrincipalCuchillo,1,<-5.0*L,0,0>) 
  #if ( FSSK_POV3_1 )
    #macro DesplazarPrincipal ( MyVector )
      MyVector+( GruesoCuchillo-GruesoFinoCuchillo )/2*y
    #end
  #else
  #local   DesplazarPrincipal   = function      {
    transform   {
      translate ( GruesoCuchillo-GruesoFinoCuchillo )/2*y
    }
  }
  #end
  FSSK_TransformBezier( IdePrincipalCuchillo, DesplazarPrincipal )
  FSSK_LaminaBezier( IdePrincipalCuchillo, <0,GruesoFinoCuchillo,0>, 0 )  
  FSSK_AjusteBezierLateral( IdePrincipalCuchillo,3,<0,-GruesoCuchillo/2,0>)
  FSSK_AjusteBezierLateral( IdePrincipalCuchillo+1,3,<0,+GruesoCuchillo/2,0>)
  #declare FSSK_ArBezierTextura[ IdePrincipalCuchillo ] = FSSK_FiloCuchillo;
  #declare FSSK_ArBezierTextura[ IdePrincipalCuchillo+1 ] = FSSK_FiloCuchillo;
  #local   IdeTroncoCuchillo            = FSSK_DefinidoB;
  #declare FSSK_DefinidoB               = FSSK_DefinidoB+1;
  FSSK_IniciarCasillaBezier
        (IdeTroncoCuchillo,
            <-LargoCuchillo,0,+ProfundidadAgarreCuchillo/2>,
            <0,0,+ProfundidadCuchillo/2>,
            <0,0,-ProfundidadCuchillo/2>,
            <-LargoCuchillo,0,-ProfundidadAgarreCuchillo/2> )  
  FSSK_AjusteCurvoBezier( IdeTroncoCuchillo, 0, 3.0, true, 1.0) 
  FSSK_AjusteCurvoBezier( IdeTroncoCuchillo, 2, 3.0, true, 1.0)
  FSSK_LaminaBezier( IdeTroncoCuchillo, <0,GruesoCuchillo,0>, 0 )  
  FSSK_AsignarTexturaBezier( IdeTroncoCuchillo+1, FSSK_TexturaTroncoDorado )
  #declare FSSK_FinCuchillo          = FSSK_DefinidoB-1;
#end

FSSK_HacerBaseCuchillo()
FSSK_HacerCuchara() 
FSSK_HacerBaseTenedor() 
FSSK_HacerCucharita()
    
#declare FSSK_Cuchara        = object        {
  FSSK_ArregloLaminadoIF( FSSK_InicioCuchara, FSSK_FinCuchara )
} 

#declare FSSK_Tenedor        = difference            {
  object        { 
    FSSK_ArregloLaminadoIF( FSSK_InicioTenedor, FSSK_FinTenedor )
  }
  #local   ProfundidadTenedor           = 25*L;
  #local   GruesoTenedor                = 1.25*L;
  #local   GruesoFinoTenedor            = 0.8125*L;
  #local   LargoPrincipalTenedor        = 53.75*L; 
  #local   LargoBaseTenedor             = 0.9*LargoPrincipalTenedor/3;    
  #local   LargoDientes                 = 2.5*LargoBaseTenedor;
  #local   HondoTenedor                 = LargoBaseTenedor/3; 
  #local   C                            = 0;
  #while ( C < 3 ) 
    sphere_sweep  { 
      linear_spline
      2,
      < LargoBaseTenedor+ProfundidadTenedor/14,-HondoTenedor, 0 >,
          0.6*ProfundidadTenedor/14,
      < LargoBaseTenedor+LargoDientes,+HondoTenedor, 0 >,
          1.4*ProfundidadTenedor/14
      translate         2*(C-1)*ProfundidadTenedor/7*z
    }                           
    #local   C                            = C+1;
  #end
}

#declare FSSK_Cuchillo       = object    {
  FSSK_ArregloLaminadoIF( FSSK_InicioCuchillo, FSSK_FinCuchillo )
  translate     -25*L*x
}

#declare FSSK_Cucharita      = object        {
  FSSK_ArregloLaminadoIF( FSSK_InicioCucharita, FSSK_FinCucharita )
} 
 
