// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 7 Noviembre 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El soporte de todos los cubiertos descansa en el plano xz
// El origen de la mayoria se encuentra en el mango
// (la parte delantera centrada del mango, inferior )
// En el caso del cuchillo el origen se desplaza
// adelante hacia la hoja, como 1/4 de longitud de hoja
// Cuchillo...
// Minimo <  -111,     0,  -12>*L
// Maximo <    67,     2,    7>*L
// Cucharita...
// Minimo <   -87,   -11,  -19>*L
// Maximo <    44,     5,   19>*L
// Cuchara...
// Minimo <  -120,   -14,  -24>*L
// Maximo <    55,     6,   24>*L
// Tenedor...
// Minimo <  -120,    -5,  -13>*L
// Maximo <    56,     6,   13>*L
//
// Algunos modificadores
// #declare FSSK_TexturaMetal           = texture { ... }
//      se refiere a la textura metalica en general  
// #declare FSSK_TexturaTroncoDorado    = texture { ... }
//      se refiere al decorado dorado
//      nicamente se aplica en la parte superior del tronco 
// #declare FSSK_TexturaCortante        = texture { ... }
//      se aplica a la zona filosa del cuchillo
// en caso de redefinirse, debera hacerlo antes del include.
//
// Para colocarlo simplemente 
// include "ForkSSK.inc";
// object { FSSK_Cucharita }, ...
// object { FSSK_Cuchara   }, ...
// object { FSSK_Cuchillo  }, ...
// object { FSSK_Tenedor   }
// nota:  el archivo "FSSK_Bez.inc", es auxiliar
//     y no se llama directamente...
//    FSSK : ForkSpoonSpoonKnife
// 

#include "colors.inc"  
#include "ForkSSK.inc"

#local OjoAbsoluto            = 256;
#local VecesCentroAbsoluto    = 10;     
#local L                      = 0.001; 

camera {
        location <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L  
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}

#local   FactorAcercamiento     = 10;
   
union    {
  object   { 
    FSSK_Cuchara
    rotate        -90*x      
    translate     100*L*y-20*L*z
  }


  object  {
    FSSK_Tenedor
    rotate        -90*x
    translate     +33.3*L*y-20*L*z
  }
   
  object  {
    FSSK_Cuchillo
    rotate        -90*x
    translate     -33.3*L*y-20*L*z
  }
  
  object   { 
    FSSK_Cucharita
    rotate        -90*x      
    translate     -100*L*y-20*L*z
  }
  
  rotate       90*z
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                                /( FactorAcercamiento )*OjoAbsoluto*L*z   
}

