// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 30 agosto 2010
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// El objeto gruta se coloca 
// en con su base frontal centrada en <0,0,0>
//
// Base de unos 3000*L de frente mas un poco mas por relieve 
// Altura algo mas de 3500*L
// tiene una entrada hacia delante de unos 20*L       
//
// Para colocarlo simplemente 
// object { GrutaVirgen }
// Algunos modificadores utiles
// que deberian declararse antes del include  
// #declare GVCR_VidrioVirgen   = off;
// elimina el vidrio de la gruta
// #declare GVCR_POV3_1         = on;
// En estado "on" realiza simplificaciones para
// que el dibujo sea compatible con POVRay 3.1.  
// En algunas versiones de POVRay se activa automticamente.
// #declare GVCR_ImagenHF       = "...";
// imagen tipo jpeg para sustituir relieve de imagen 
//      ( gif en modo POVRay 3.1. )    
// #declare GVCR_TexturaPiedra  = texture {}
// textura a aplicar a la gruta        
// #declare GVCR_TexturaImagen  = texture {}
// para reemplazar la textura de Jade de la imagen
// #declare GVCR_TexturaBase    = texture {}
// para aplicar a la base que soporta el vidrio y la imagen
// #declare GVCR_TexturaOro     = texture {}
// para aplicar a la barrita de oro decorativa
// #declare GVCR_TexturaVidrio  = texture {}
// para aplicar al vidrio cobertor 
//

#include "colors.inc"
#include "textures.inc"    
#include "stones.inc"

#ifndef ( GVCR_POV3_1 ) 
  #if ( version < 3.2 )
    #declare GVCR_POV3_1        = on;
  #else
    #declare GVCR_POV3_1        = off;
  #end
#end

#if ( GVCR_POV3_1 = off )
  #include "functions.inc"
#end
   
#local L                      = 0.001;

#ifndef ( GVCR_VidrioVirgen )
  #declare GVCR_VidrioVirgen         = on;
#end

#declare GVCR_GrutaVirgen    = union {   
  #if ( GVCR_POV3_1 = off )
  isosurface      {
        function        { 
                 min(
                       max( f_sphere( x, y , z, 1.5 ),
                       -f_sphere( x, y, z, 1.0 ), -y, -z ),
                       max( sqrt( pow( x, 2 )+pow( z, 2 ) )-1.5,
                       1.0-sqrt( pow( x, 2 )+pow( z, 2 ) ), -y-2, -z, y ),
                       max( sqrt( pow( x-1.25, 2 )+pow( z, 2 ) )-0.25,
                                -y-2, y ),
                       max( sqrt( pow( x+1.25, 2 )+pow( z, 2 ) )-0.25,
                                -y-2, y ),
                       max( f_torus( x,z,y,1.25,0.25), -y )
                    )
                 -f_noise3d( x*8, y*8,z*8 )*.1
        }
        contained_by    {
                 box    { -2, 2 }
        }
        scale           1000
        #ifndef ( GVCR_TexturaPiedra )
          texture         { T_Stone28 }
        #else
          texture         { GVCR_TexturaPiedra }      
        #end
        translate       1000*y
  }
  #else    
    union               {
      difference        {
        sphere          {
          0     , 1.5
        }
        sphere          {
          0     , 1.0
        } 
        plane           {
          y     , 0
        }
        plane           {
          z     , 0
        }
      } 
      difference        {
        torus           {
          1.25  , 0.25
          rotate        90*x
        }
        plane           {
          y      , 0
        }
        plane           {
          -z     , 0
        }
      }
      difference        {
        cylinder        {
          -2*y          , 0.0           , 1.5
        }
        cylinder        {
          -2.1*y        , 0.1*y         , 1.0
        }
        plane           {
          z     , 0
        }
      }
      cylinder          {
        1.25*x  , 1.25*x-2*y    , 0.25
      }
      cylinder          {
        -1.25*x  , -1.25*x-2*y    , 0.25
      }
      scale           1000
        #ifndef ( GVCR_TexturaPiedra )
          texture         { T_Stone28 }
        #else
          texture         { GVCR_TexturaPiedra }      
        #end
      translate       1000*y        
    }
  #end  

  union           {
        height_field    { 
          #ifndef ( GVCR_ImagenHF )
            gif    "GVCR_Vir.gif"
          #else   
            #if ( GVCR_POV3_1 )
              gif  GVCR_ImagenHF
            #else
              jpeg GVCR_ImagenHF
            #end
          #end
                 
                 smooth
                 scale          < 300, 100, 300 >     
                 translate      < -150   , -50   , -150   >
                 rotate         90*x+180*z
                 translate      -20*z
        }
#local    B11    = < -150, 225   , 150   >; 
#local    B12    = < -100, 425   , 150   >; 
#local    B13    = < 100 , 425   , 100   >;
#local    B14    = < 150 , 225   , 150   >;      // row 1
#local    B21    = < -150, 225   , 100   >; 
#local    B22    = < -100, 425   , 100   >; 
#local    B23    = < 100 , 425   , 100   >;
#local    B24    = < 150 , 225   , 100   >;      // row 2
#local    B31    = < -150, 200   , 0     >; 
#local    B32    = < -50 , 200   , 0     >; 
#local    B33    = < 50  , 200   , 0     >;
#local    B34    = < 150 , 200   , 1     >;      // row 3
#local    B41    = < -150, 150   , 0     >; 
#local    B42    = < -50 , 150   , 0     >; 
#local    B43    = < 50  , 150   , 0     >;
#local    B44    = < 150 , 150   , 0     >;      // row 4
  bicubic_patch   {
         type           1
         flatness       0.001
         u_steps        4
         v_steps        4
         #if ( GVCR_POV3_1 = off )
         uv_vectors
         < 0    , 0     >
         < 1    , 0     >
         < 1    , 1     >
         < 0    , 1     >
         #end
         B11,   B12     , B13   , B14
         B21,   B22     , B23   , B24
         B31,   B32     , B33   , B34
         B41,   B42     , B43   , B44
  }     
#local    B11    = < 150 , 150   , 0     >; 
#local    B12    = < 200 , 150   , 0     >; 
#local    B13    = < 250 , 150     100   >;
#local    B14    = < 250 , 150   , 150   >;      // row 1
#local    B21    = < 150 , 100   , 0     >; 
#local    B22    = < 200 , 100   , 0     >; 
#local    B23    = < 300 , 200   , 100   >;
#local    B24    = < 300 , 200   , 150   >;      // row 2
#local    B31    = < 150 , -100  , 0     >; 
#local    B32    = < 200 , -100  , 0     >; 
#local    B33    = < 300 , -100  , 100   >;
#local    B34    = < 300 , -100  , 150   >;      // row 3
#local    B41    = < 150 , -150  , 0     >; 
#local    B42    = < 200 , -150  , 0     >; 
#local    B43    = < 300 , -150  , 100   >;
#local    B44    = < 300 , -150  , 150   >;      // row 4
  #local    lateralinf    = bicubic_patch   {
         type           1
         flatness       0.001
         u_steps        4
         v_steps        4
         #if ( GVCR_POV3_1 = off )
         uv_vectors
         < 0    , 0     >
         < 1    , 0     >
         < 1    , 1     >
         < 0    , 1     >
         #end
         B11,   B12     , B13   , B14
         B21,   B22     , B23   , B24
         B31,   B32     , B33   , B34
         B41,   B42     , B43   , B44
  }
  object  {
        lateralinf
  }
  object  {
         lateralinf         
         scale          < -1    , 1     , 1     >
  }     
#local    B11    = < 150 , 225   , 150   >; 
#local    B12    = < 200 , 175   , 150   >; 
#local    B13    = < 175 , 275     150   >;
#local    B14    = < 225 , 225   , 150   >;      // row 1
#local    B21    = < 150 , 225   , 100   >; 
#local    B22    = < 200 , 175   , 100   >; 
#local    B23    = < 225 , 255   , 100   >;
#local    B24    = < 275 , 175   , 150   >;      // row 2
#local    B31    = < 150 , 200   , 0     >; 
#local    B32    = < 250 , 200   , 0     >; 
#local    B33    = < 200 , 100   , 100   >;
#local    B34    = < 200 , 100   , 150   >;      // row 3
#local    B41    = < 150 , 150   , 0     >; 
#local    B42    = < 200 , 150   , 0     >; 
#local    B43    = < 250 , 150   , 100   >;
#local    B44    = < 250 , 150   , 150   >;      // row 4
  #local    lateralinf    = bicubic_patch   {
         type           1
         flatness       0.001
         u_steps        4
         v_steps        4
         #if ( GVCR_POV3_1 = off )
         uv_vectors
         < 0    , 0     >
         < 1    , 0     >
         < 1    , 1     >
         < 0    , 1     >
         #end
         B11,   B12     , B13   , B14
         B21,   B22     , B23   , B24
         B31,   B32     , B33   , B34
         B41,   B42     , B43   , B44
  }
  object  {
        lateralinf
  }
  object  {
         lateralinf         
         scale          < -1    , 1     , 1     >
  }  
    #ifndef ( GVCR_TexturaImagen )
      texture  {
        pigment { Jade scale 300 }
      }
    #else
      texture  { GVCR_TexturaImagen }
    #end  
        scale   2*y
        translate       200*z 
  }  
  box     {
         < -1000, -1000 , -20   >,
         < 1000 , 0     , 1000  > 
       #ifndef ( GVCR_TexturaBase)  
         texture        {
                 PinkAlabaster
                 scale  2000
         }
       #else
         texture        { GVCR_TexturaBase }
       #end
  }
  cylinder        {
         < -1000, 0     , 0     >,
         < 1000 , 0     , 0     >, 10
      #ifndef ( GVCR_TexturaOro )
      texture   {            
        pigment         { BrightGold }
        finish          {
                         ambient        .1
                         diffuse        .4
                         reflection     .25
                         specular       1
                         metallic
        }
      }
      #else
        texture { GVCR_TexturaOro }
      #end
  }
  #if ( GVCR_VidrioVirgen = on )
    polygon       {
        5,
        <-1000,   0>,
        < 1000,   0>,
        < 1000,2000>,
        <-1000,2000>,
        <-1000,   0>   
        #ifndef ( GVCR_TexturaVidrio )
        pigment        {
                White filter .9
        }
        normal         { bumps 0.2 scale 200 }
        finish         {
                phong .5
        }
        #else
          texture { GVCR_TexturaVidrio }
        #end
    }
  #end
  scale         L 
  translate     1000*y*L  
}
