// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica 
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 febrero 2011
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// "MesaTVC.inc" dibuja una mesa para terraza
// Sus dimensiones son ( sin deformaciones adicionales ):
// Alto                 = 535*L 
//             514+21*FactorGrueso si utiliza la macro
// Radio                = 325*L
//             RadioPrincipal si utiliza la macro         
// Su ubicacion primaria descansa sobre el plano XZ centrado en el origen.
//
// Para ponerlo en pantalla simplemente utilice la macro default
// #include "MesaTVC.inc"
// object { MTVC_MesaTerraza() }
// Si utiliza el FreeDOS, con la version 3.1 de PovRay
// #declare MTVC_POV3_1 = on;
// #include "MesaTVC.inc"
// object { MTVC_MesaTerraza() }
//
// Otra alternativa disponible es utilizar la macro:
// object { MTVC_MesaTerraza
//      ( RadioPrincipal, RadioMedio, FactorGrueso, 
//                TexturaMetal, MaterialVidrio ) } 
//      RadioPrincipal  : radio del vidrio
//      RadioMedio      : radio de la zona inferior
//      FactorGrueso    : 1.0 es default, amplifica o disminuye
//              el grueso de las barras
//      TexturaMetal    : Textura del objeto fundamental
//      MaterialVidrio  : tipo material para describir el vidrio
//
// Para accesar a las siguientes texturas basicas que
// no deberian modificarse, las variables son
// #declare MTVC_TexturaMetal
// #declare MTVC_MaterialVidrio
// Si usted desea modificar la textura default, utilice 
// las siguientes variables
// #declare MTVC_TexturaMetalDefault
// #declare MTVC_MaterialVidrioDefault
// Por ejemplo 
// #include "TrasteroSMB.inc"
// #declare CustomTextura               = texture       {
//   pigment            { Cyan }
// }
// #declare TSMB_TexturaMetalDefault    = texture       {
//   average
//   texture_map   {
//      [ 0.5 MTVC_TexturaMetal        ]
//      [ 0.5 CustomTextura            ]
//   }
// }
// object { MTVC_TexturaMetal() }
// otros modificadores ( se indican valores default)
// #declare MTVC_POV3_1                 = off;
//      "on" desactiva procesos y algoritmos POVRAY 3.6, 
//      para mantener compatibilidad con POVRAY 3.1.
//      en algunas versiones de POVRay se activa automticamente. 
// #declare MTVC_FactorLargoEstimadoV   = 1.0;  
//      en caso de que los decorados superiores, adyacentes al vidrio
//      resulten muy largos o muy pequeos, puede usarse
//      este factor para intentar remediar el problema.
// #declare MTVC_FactorDecorado         = 0.98;
//      si el decorado lateral queda muy adentro o muy afuera,
//      podria utilizarse este modificador para "hacerlo" calzar.
//
 
#include "colors.inc"
#local    OjoAbsoluto            = 256;
#local    VecesCentroAbsoluto    = 10;     
#local    L                      = 0.001;
camera {
        location <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L  
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    


#include "MesaTVC.inc"

object  {
  MTVC_MesaTerraza()
  translate     -250*L*y-1500*L*z
}